#!/usr/local/bin/python3
import sys, os, cgi, subprocess, random, glob, time, re
from engine.as_hlp import hlp
from engine.problems import check_problems
from engine.config_editor_class import Config

sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n')

check_problems()

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

form = cgi.FieldStorage()
os.dup2(1, 2)
cmd = form.getvalue('cmd')
mod = form.getvalue('mod', '')

import sqlite3

if 'cnf_id' in form:
	cnf_id = form.getvalue('cnf_id')
	cnf_text = '?cnf_id=' + cnf_id
else:
	cnf_id = False
	cnf_text = ''


cnf_path = 'config.ini' if not cnf_id else 'configs/%s/config.ini' % cnf_id
cnf = Config(cnf_path)
cnf.parseLang()

db_path = 'data.db' if not cnf_id else './configs/%s/data.db' % cnf_id

conn = sqlite3.connect(db_path, isolation_level='IMMEDIATE')
cursor = conn.cursor()

_print('<html><head><title>control center</title><link href="res/asfw.css?rnd=%d" rel="stylesheet" type="text/css" /></head><body>' % random.randint(0, 100))

if cmd == 'rm_errors':
	hlp.execute('rm -f errors/*')
	#_print('<p>все ошибки удалены</p><meta http-equiv="refresh" content="1; url=cp.py" />')

if cmd == 'vacuum':

	cursor.execute('VACUUM')
	conn.commit()

errorsz = hlp.execute('ls errors | wc -l', silent=False)
dbsz = os.stat(db_path)[6] / 1024


cnf_text2 = cnf_text.replace('?', '')

t_1 = cnf.trans('Панель управления')
t_2 = cnf.trans('назад')
t_3 = cnf.trans('настройки')
t_4 = cnf.trans('данные')
t_5 = cnf.trans('логи')
t_6 = cnf.trans('справка')
t_7 = cnf.trans('удалить все ошибки')
t_8 = cnf.trans('действительно остановить все скрипты?')
t_9 = cnf.trans('остановить все копии скрипта командой stop')
t_10 = cnf.trans('уплотнить БД (сейчас')


_print('''
<div id='countersMain' style='border: 1px dotted black; margin-top: 0px; z-index: -100'>
<span id='counters' style=''><p style='text-align: center'><img src='res/loading.gif' alt='loading..' /></p></span>
</div>
<script>
function g(id)
{
    return document.getElementById(id)
}

function ajax(url, callback)
{
    var xmlhttp = new XMLHttpRequest()
    xmlhttp.open('GET', url)

    xmlhttp.onreadystatechange = function ()
    {
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200)
              callback(xmlhttp)
        else
            console.log('start.pyw function ajax fail')
    }

    xmlhttp.send(null);
}

function setCnts(xmlhttp)
{
	g('counters').innerHTML = xmlhttp.responseText
}

function setProcs(xmlhttp)
{
	g('processes').innerHTML = xmlhttp.responseText
}

function updateCounters()
{
	ajax('engine/get_cnts.py%(cnf_text)s', setCnts)
}

function updateProcesses()
{
	ajax('engine/get_processes.py', setProcs)
}

window.timerCnt = window.setInterval('updateCounters()', 2000);
window.timerProc = window.setInterval('updateProcesses()', 2000);
</script>

<ul id='cpMenuUl'>
<li><a href='cp.py%(cnf_text)s'>%(t_1)s</a></li><br /><br /><br />
	<li><a href="start.pyw">&larr; %(t_2)s</a></li>
	<!--<li><a href="start.pyw%(cnf_text)s">старт с логом</a></li>-->
	<li><a href="config_editor.py%(cnf_text)s">%(t_3)s</a></li>
	<li><a href="fileed_sql.py?table=twits&%(cnf_text2)s">%(t_4)s</a></li>
	<li><a href="?cmd=logs&%(cnf_text2)s">%(t_5)s</a></li>
	<!--<li><a href="?cmd=updatedb">база данных</a></li>-->
	<li><a href="manual.html">%(t_6)s</a></li>
	<li>&nbsp;&nbsp;&nbsp;&nbsp;</li>
	<!--<li><a href="?cmd=start&%(cnf_text2)s" style='font-weight: bold'>запустить скрипт</a></li>-->
</ul><p style='margin-left: 50px'>
	<a href='?cmd=rm_errors'>%(t_7)s (%(errorsz)s)</a>&nbsp;&nbsp;&bull;&nbsp;&nbsp;
	<a href='?cmd=stop' onclick='return confirm("%(t_8)s")'>%(t_9)s</a>&nbsp;&nbsp;&bull;&nbsp;&nbsp;
	<a href='?cmd=vacuum&%(cnf_text2)s'>%(t_10)s %(dbsz)s kb)</a>&nbsp;&nbsp;&nbsp;&nbsp;
</p>
<p>&nbsp;</p>
''' % locals())






#.format(cnf_text, attachs, errorsz, dbsz))

# % (cnf_text, attachs, errorsz, dbsz)) %2.2f

if cmd == 'kill':
	pid = int(form.getvalue('pid'))
	_print(cnf.trans('Попытка убить процесс')  + ' #%d..' % pid)#

	proc = subprocess.Popen(r'kill %d' % pid, shell=True,
			stdout=subprocess.PIPE, stdin=subprocess.PIPE)

if cmd == 'logs':

	log_path = 'tmp/'
	if cnf_id:
		log_path = 'configs/%s/' % cnf_id

	if 'delall' in form:
		hlp.execute('rm %s*_log.txt' % log_path)
		_print('<p>%s</p><meta http-equiv="refresh" content="1; url=?cmd=logs&%s" />' % (cnf.trans('все логи удалены'), cnf_text2))

	if 'del' in form:
		fullpath = form.getvalue('del').strip()

		if os.path.exists(fullpath):
			os.unlink(fullpath)
			_print(cnf.trans('удалён') + ' %s<br /><br />' % fullpath)

	total = glob.glob(log_path + '*_log.txt')

	if len(total):

		logs = []

		for log_name in total:

			filesz = os.stat(log_name)[6] / 1024

			try:
				parts = re.findall(log_path + r'([0-9]+).([0-9]+)_([0-9]+):([0-9]+):([0-9]+)_log.txt', log_name)[0]
				months = {
					'01':cnf.trans('января'),
					'02':cnf.trans('февраля'),
					'03':cnf.trans('марта'),
					'04':cnf.trans('апреля'),
					'05':cnf.trans('мая'),
					'06':cnf.trans('июня'),
					'07':cnf.trans('июля'),
					'08':cnf.trans('августа'),
					'09':cnf.trans('сентября'),
					'10':cnf.trans('октября'),
					'11':cnf.trans('ноября'),
					'12':cnf.trans('декабря'),
				}
				formatted_name = '%s %s, %s:%s:%s' % (parts[0], months[parts[1]], parts[2], parts[3], parts[4])
			except:
				formatted_name = log_name

			logs.append('<li style="margin-top: 0px"><a href="engine/log_viewer.py?file=%s">%s</a> <small style="color: #333">%2.2f kb</small>&nbsp;&nbsp;&nbsp;<a href="?cmd=logs&del=%s">%s</a></li>\n' % (log_name, formatted_name, filesz, log_name, cnf.trans('удалить')))

		_print('<p style="margin-left: 50px"><b>%s</b>&nbsp;&nbsp;&nbsp; <a href="?cmd=logs&delall=true&%s">%s</a></p><br /> <ul>%s</ul>' % (cnf.trans('Все логи'), cnf_text2, cnf.trans('удалить все'), ''.join(logs)))
	else:
		_print('&nbsp;'*10 + cnf.trans('нет логов'))


if cmd == 'start':

	logname = time.strftime('tmp/%d.%m_%H:%M:%S_log.txt', time.localtime())

	to_start = '/usr/local/bin/python3 start.pyw start'

	if cnf_id:
		to_start += ' cnf_id=' + str(cnf_id)

	if mod:
		to_start += ' mod=' + str(mod)

	r = subprocess.Popen(to_start, shell=True,
	stdout=open(logname, 'w'), stdin=subprocess.PIPE)

	_print(cnf.trans('Запустили новую копию, лог') + ' <a href="engine/log_viewer.py?file=%s">%s</a>' % (logname, logname))

if cmd == 'stop':
	with open('engine/cmd.txt', 'w') as f:
		f.write('stop')
	_print(cnf.trans('Команда "остановить" послана всем копиям в текущей папке'))


_print(r'''
<div style='z-index: 100; position: absolute; top: 10px; border-bottom: 1px dotted grey; padding: 20px; width: 100%%; margin-left: 0; left: 0; '><h3>{0} python3</h3>
<pre id='processes'><p style='text-align: center; width: 400px'><img src='res/loading.gif' alt='loading..' /></p></pre>
</div>
'''.format(cnf.trans('Процессы')))

