import os, sys, time, json, queue
from threading import RLock
#from PyQt4 import QtCore, QtGui
from engine.as_sqlite import asSqlite_deferred
from threading import Event
from engine import *


#gifts:

# а это и есть глобальный PARENT
class asBase:
	''' main class '''

	threadsStopped = Event() # флаг, который ставит as_proxy когда завершены все потоки

	data = {} # old сюда прелоадятся все файлы - недоделано, щас после редактирования файла надо блядь перезапускать
	odd = False
	lock = RLock()

	sqltables = []
	sqltable_cols = {} # строки для вставки в таблицы, типа 'null, "%s", 0'
	sqlite_storage = {} # хранилище прекэшированных данных из таблиц sqlite

	counters = {} # тут храним счётчики, их имена и значения
	counters_map = {} # пары счетчик - индекс в counters, чтобы hlp.cnt мог найти счетчик

	def __init__(self, db_path='./data.db', cnf_path='./config.ini', cnf_id=False, runmode='cgi', lightload=False):
		''' инициализируем gui '''
		self.q_app = None
		self.cnf_id = cnf_id
		self.db_path = db_path
		self.cnf_path = cnf_path
		self.runmode = runmode
		self.sqlite_storage = {'proxy': []}

		# парсим переводчик
		#~ with open('res/lang', 'rb') as fp:
			#~ data = fp.read().decode('utf-8', 'ignore')

		self.lang_rows = {}

		if os.path.exists('res/lang'):
			for r in open('res/lang', 'rb'):
				row = r.decode('utf-8', 'ignore').strip()
				if not row.startswith('#') and row.strip() and '|' in row:
					src, eng = row.split('|')
					self.lang_rows[src] = eng

		if cnf_id:
			t_path = 'configs/%s/' % cnf_id
			self.logname = t_path + time.strftime('%d.%m_%H-%M-%S_log.txt', time.localtime())
		else:
			self.logname = time.strftime('tmp/%d.%m_%H-%M-%S_log.txt', time.localtime())

		self.gui = asGui(self.q_app, self)
		self.hlp = hlp(self)

		self.cnf = asCnf(self, cnf_path=cnf_path)
		self.sqlite = asSqlite(parent=self, dbpath=db_path, lightload=lightload)
		self.tid = None
		self.sqlite_def = asSqlite_deferred(self.cnf.getbool('sqldebug'), parent=self)

		#~ cnts = self.sqlite.exec('select name, fullname from _counters')
		#~ for name, fullname in cnts:
			#~ self.counters[name] = {'name': fullname, 'value': 0}

		flags = self.sqlite.exec('select value from _settings where option="flags"')[0][0]

		if self.cnf.getbool('debug'):
			self.sqlite.debug = True

		self.file = asFile(self)

		# для антикапчи
		self.http = asHttp(self, self.cnf.getbool('httpdebug'))

		if not self.cnf.get('ac_key').strip():
			localKey = '/home/deex/www/ac.key'
			if os.path.exists(localKey):
				with open(localKey, 'r') as f:
					self.cnf.set('ac_key', f.read().strip())

		self.proxy = asProxy(self)
		self.threads = asThreads(self)

		self.queue = asQueue(self)
		self.log_queue = queue.Queue()
		self.queue.addEvent('stop_right_there') # or I'll shoot

		# пишем счетчики в память
		with open('engine/counters.map', 'rb') as fp:
			data = fp.read().decode('utf-8')

			for l in data.split('\n'):
				if not l.strip():
					continue
				num, name, descr, value = l.split(':')
				if num: num = int(num)
				if value: value = int(value)

				if isinstance(value, str) and value.strip() == '':
					value = 0

				self.counters[num] = {'name':name, 'value':value, 'descr':descr}
				self.counters_map[name] = num

	def __del__(self):
		#self.text_log_hnd.close()
		pass

	def run(self, modstart):
		''' инициализация модулей фреймворка '''

		# инициализируем бота
		mods = os.listdir('include')
		mods = [filen.replace('mod_', '').replace('.py', '') for filen in mods if 'mod_' in filen and '.py' in filen]

		for mod in mods:
			modi = __import__('include.mod_' + mod, globals(), locals(), fromlist=True)
			m = getattr(modi, mod)(self)
			setattr(self, mod, m)

		# создаем лог-файл
		if self.cnf.getbool('text_log'):
			with open(self.logname, 'w') as f:
				pass

		# чистим счетчики
		#self.sqlite.exec('update _counters set value = 0')

		self.proxy.load()
		self.log('запускаем модуль ' + str(modstart))
		getattr(self, modstart).init()
		getattr(self, modstart).start()

	def run_proxy_tests(self):
		#грузим прокси
		#пишем скока их в списке
		#определяем голый ип
		#начинаем чекать через майип.яндекс, выводим те, которые не соответствуют
		pass

	def log(self, text, ctype='&nbsp;&nbsp;', tid=None, hide=False):
		'''
			хитрые выебоны чтобы выводить то что нужно.
			1 text - может быть сраной строкой. её просто ищут в lang
			2 text - может быть списком. тогда первый элемент отрывают и пробуют перевести, а все остальные юзают как аргументы для .format()
			3 text - может быть tuple (part1, part2, part3). Тогда пытается перевести каждую часть и склеивает их воедино блядь

		'''
		#import sys
		# если перевод res/lang есть:
		if self.lang_rows:

			# если это set - ищем перевод для каждого куска и склеиваем
			if isinstance(text, tuple):
				newrow = ''
				for p in text:
					p = str(p)
					if p in self.lang_rows.keys():
						newrow += self.lang_rows[p].strip()
						if p.endswith(' '):
							newrow += ' '
					else:
						newrow += p
				text = newrow

			# если текст обычный - ищем перевод
			elif isinstance(text, str):
				if text in self.lang_rows.keys():
					text = self.lang_rows[text]

			# если получили лист - ищем перевод по ИД
			elif isinstance(text, list):
				t_id = text.pop(0)
				params = text

				if t_id in self.lang_rows.keys():
					text = self.lang_rows[t_id]
					# подставляем остальные параметры
					try:
						text = text.format(*params)
					except:
						text = '<b>FORMAT_T_EXCEPTION</b> ' + str(t_id)
				else:
					text = '<b>TRANSLATE_NOT_FOUND</b> ' + str(t_id)

			else:
				text = '<b>WTF_T</b> ' + text
		else:
			# обрабатываем без перевода
			# если это set - склеиваем
			if isinstance(text, tuple):
				text = [str(t) for t in text]
				text = ''.join(text)
			# если получили лист - форматируем по параметрам
			elif isinstance(text, list):
				t_id = text.pop(0)
				params = text
				try:
					text = t_id.format(*params)
				except:
					text = '<b>FORMAT_T_EXCEPTION</b> ' + str(t_id)

		# просто выводим текст без форматирования
		if hide:
			self._print(text)
			return

		tidt = '#%d' % tid if tid is not None else ''

		# форматируем для консоли
		if self.runmode == 'console' and not self.cnf.getbool('text_log'):
			msg = '%s [%s] %s\n' % (tidt, ctype, text)

		# форматируем для веб
		if	self.runmode == 'cgi' or self.cnf.getbool('text_log'):

			ctypes = {'!':'red', '+':'blue', '*':'orange', '$':'#FDEB4A',
							'><':'#FF0000', '-':'#99FD9E', '~':'grey', '%': '#000'}
			if ctype in ctypes.keys():
				ctype_n = ctypes[ctype]
			else:
				ctype_n = ctype

			if ctype == '%':
				st = 'background-color: #C7E5F3'
			else:
				st = ''
			color = 'color: ' + ctype_n
			odd = 'drk' if self.odd else ''
			self.odd = False if self.odd else True

			msg = '<p threadid="{0}" class="logline {1}" style="{5}">{0} <span style="{2}">[{3}]</span> {4}</p>\n'.format(tidt, odd, color, ctype, text, st)

		# печать
		if self.cnf.getbool('console_html_log'):
			self._print(msg)

		if self.cnf.getbool('text_log'):
			# добавляем в очередь
			#msg = '%s [%s] %s\n' % (tidt, ctype, text)
			self.log_queue.put(msg)


	def _print(self, msg):

		sys.stdout.buffer.write(msg.encode('utf8'))
		sys.stdout.flush()

	def processQueues(self, data):
		''' обработка заданий, накопившихся в queue '''
		if data == 'thread_done':
			#self.gui.lbl('threads', '-')
			self.hlp.cnt('threads', 'dec')
		elif data == 'thread_start':
			self.hlp.cnt('threads')
		elif data[0] == 'log':
			self.gui.logger(data[1], data[2])
		elif data[0] == 'inc':
			self.gui.lbl(data[1], '+')
		#else:
		#	self.grabber.processQueues(data)


