import os
from threading import RLock

class asFile():

	def __init__(self, parent=None):
		if parent:
			self.parent = parent

	def add(self, name, data, mode='a'):
		''' add line or list to file '''

		if type(data) == list:
			line = '\n'.join(data) + '\n'
		else:
			line = data + '\n'

		with open('res/' + name, mode) as file:
			file.write(line)

	def mv(self, src, to, data):

		self.rm(src, data)
		self.add(to, data)

	def rm(self, name, data=False):
		''' remove data from a file '''

		if data is False:
			# удаляем файл
			os.unlink(name)
			return

		data = bytes(data, 'utf-8')

		lock = RLock()
		with lock:
			with open('res/' + name, 'rb') as file:
				body = file.read()
				if data + b'\n' in body:
					body = body.replace(data + b'\n', b'')
				elif data + b'\r\n' in body:
					body = body.replace(data + b'\r\n', b'')
				else:
					body = body.replace(data, b'')

			with open('res/' + name, 'wb') as file:
				#file.write(bytes(body, 'utf-8'))
				file.write(body)

	def save(self, name, data):
		''' clear file, save data to file '''
		self.add(name, data, 'w')

	def load(self, name, isList=True):

		data = ''
		with open('res/' + name, 'rb') as file:
			data = file.read().decode('utf-8', 'ignore').strip()
			if isList:
				data = [line.strip() for line in data.split('\n') if line.strip()]
				data = list(set(data))

		return data

	def clear(self, name):
		with open('res/' + name, 'w') as file:
			pass
