from engine.as_file import asFile

class asFileEd():

    current_opened = ''
    info = {} # имя файла: (название файла, описание)
    info_helper = {} # название файла: имя файла

    def __init__(self, parent=None):
        if parent:
            self.parent = parent

        info = asFile().load('file_info.txt')
        for line in info:
            try:
                file, name, desc = line.split('|', 2)
            except:
                file, name = line.split('|', 2)
                desc = name

            self.info[file + '.txt'] = (name.strip(), desc.strip())
            self.info_helper[name.strip()] = file + '.txt'

            self.parent.gui.combo('files', 'add', (name.strip(), file + '.txt'))

    def load_current(self, name):

        if not name.strip():
            return

        self.load(self.info_helper[name])

    def load(self, name):
        data = asFile().load(name)
        self.current_opened = name
        self.parent.gui.plainTextEdit('filearea', 'set', data)
        self.parent.gui.lbl('lines_in_file', 'set', len(data))

        if name in self.info:
            self.set_description(name)


    def set_description(self, filename):
        self.parent.gui.lbl('description', 'set', self.info[filename][1])

    def save_current(self):
        ''' name - название файла, типа "имейлы" '''

        currentName = self.parent.gui.combo('files', 'getvalue')
        data = self.parent.gui.plainTextEdit('filearea', 'get')

        fname = self.info_helper[currentName]

        self.parent.file.save(fname, data)
        self.parent.log(('сохранен ', fname))
        self.load(self.info_helper[currentName])

        #if fname == 'proxy.txt':
        #    self.parent.data[fname] = data.strip().split('\n')


    def clear(self):
        self.parent.file.clear(self.current_opened)
        self.parent.gui.plainTextEdit('filearea', 'clear')
