import os, re, string, random, sys, time, subprocess
from urllib.parse import quote, unquote, quote_plus, unquote_plus, urlencode

if 'engine' in os.getcwd():
	from as_sqlite import asSqlite_deferred
else:
	from engine.as_sqlite import asSqlite_deferred

from threading import RLock

class hlp:

	PATTERN_EMAIL = r'([0-9a-zA-Z_&.%+-]+@[0-9a-zA-Z\-]+\.?[\.a-zA-Z0-9]{2,20})'
	PATTERN_PROXY = r'([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}:[0-9]{2,6})'
	PATTERN_PROXY_2 = r'([0-9\-a-z\-\.]+:[0-9]{2,5})'

	def __init__(self, parent):
		self.parent = parent
		self.lock = RLock()

	def exists(path):
		return bool(os.path.exists(path))

	def fix_emails(page):
		return page.replace('\\u0040', '@').replace('&#64;', '@')

	def ls(dirname, only_folders=False):
		if not os.path.exists(dirname):
			return False
		data = os.listdir(dirname)
		if only_folders:
			data = [d for d in data if os.path.isdir(dirname + '/' + d)]

		return data

	def quote(text):
		return quote(text)

	def time(full=False):
		return time.time() if full else int(time.time())

	def unquote(text):
		return unquote(text)

	def quote_plus(text):
		return quote_plus(text)

	def unquote_plus(text):
		return unquote_plus(text)

	def urlencode(text):
		return urlencode(text)

	def password(len=7, withDigits=True, onlyDigits=False):
		''' генерирует пароль из букв и цифр длиной len '''
		src = string.ascii_letters

		if withDigits:
			src += string.digits

		if onlyDigits:
			src = string.digits

		result = ''
		for i in range(len):
			result += random.choice(src)

		return result

	def redir(url, sleep=0):
		print("redirect to %(url)s after %(sleep)s seconds.. <meta http-equiv='refresh' content='%(sleep)s; url=%(url)s'>" % locals())
		sys.exit(0)

	def slp(self, delay, log=False):
		'''
		self.hlp.slp(5)
		self.hlp.slp('spamer_delay')
		self.hlp.slp(self.cnf.get('spamer_delay')) '''

		if isinstance(delay, int):
			delay_s = delay
		else:
			if 'delay' in delay:
				delay = self.parent.cnf.get(delay)

			if '-' in delay:
				delay_s = hlp.rand(delay)
			else:
				delay_s = int(delay)

		if log:
			log.log('спим {0} сек.'.format(delay_s))
		else:
			self.parent.log('спим {0} сек.'.format(delay_s))

		time.sleep(delay_s)

	def md5(text):
		import hashlib

		if isinstance(text, str):
			text = text.encode('utf-8', 'ignore')

		return hashlib.md5(text).hexdigest()

	def dx(text, tid=0):
		'''print lists'''

		import sys

		result = ''
		for elem in text:
			result += ', ' + str(elem)

		msg = '<p threadid="%s" class="logline">#%s [size: %s] %s</p>\n' % \
			  (tid, tid, len(text), result)

		sys.stdout.buffer.write(msg.encode('utf8'))
		sys.stdout.flush()


	def strip_tags(data):
		patt = re.compile(r'<.*?>')
		return patt.sub('', data)

	def parse(pattern, data):
		''' возвращает первое совпадение pattern в data
		макросы *SPACE* -  '[\S\s]*?' , *VALUE* - '([^"]+)'
		'''

		if isinstance(pattern, list):
			for patt in pattern:
				res = hlp.parse(patt, data)

				if res is not False:
					return res

			return False

		pattern = hlp._pattern_hlp(pattern)

		m = re.search(pattern, data)

		if not m:
			return False

		return m.group(1)

	def stop():
		''' пишет в engine/cmd.txt - stop '''

		with open('engine/cmd.txt', 'wb') as f:
			f.write(b'stop')

		print('<script>stop_script()</script>')

		try:
			sys.exit(0)
		except:
			pass

	def _pattern_hlp(pattern):
		'''
		макросы *SPACE* -  '[\S\s]*?' , *VALUE* - '([^"]+)'
		'''
		# пустые места, переводы строк
		pattern = pattern.replace('*SPACE*', '[\S\s]*?')

		# выдирать значение до "
		pattern = pattern.replace('*VALUE*', '([^"]+)')

		# выдирать значение до '
		pattern = pattern.replace('*VALUE2*', "([^']+)")

		return pattern

	def parse_all(pattern, data):
		''' возвращает все совпадения pattern в data '''

		pattern = hlp._pattern_hlp(pattern)
		try:
			data = re.findall(pattern, data)
		except:
			print('error parse with pattern: %s' % pattern)
			return False

		if isinstance(data, list) and len(data):
			return data
		else:
			return False


	def next(arr):
		''' возвращает элементы списка arr по очереди '''
		el = arr.pop(0)
		arr.append(el)
		return el

	def txt(phrases, body):
		''' ищет фразы списка phrases в body '''

		if isinstance(phrases, str):
			phrases = [phrases]

		for phrase in phrases:
			if phrase in body:
				return True

		return False

	def rand(one, two=0):
		'''
		1 one - массив. возвращает рандом элемент из него
		2 one - цифра, two не указан или 0 - возвращает рандом число от 0 до one
		3 one и two - цифры, второй больше первого - возвращает рандом число от one до two
		4 one - строка типа "1-5", выбирается рандом элемент
		'''

		if isinstance(one, dict):
			if not len(one.items()):
				return False
			arr = list(one.items())
			return random.choice(arr)
		elif isinstance(one, list):
			if not len(one):
				return False
			return random.choice(one)
		elif isinstance(one, int):
			if two > 0:
				return random.randint(one, two)
			else:
				return random.randint(0, one)
		elif isinstance(one, str) and '-' in one and len(one) > 2:
			t1, t2 = one.split('-')
			return random.randint(int(t1), int(t2))
		else:
			raise Exception('incorrect hlp.rand parameters: "{0}", "{1}"'.format(one, two))

	def lnk(path, name, style=''):
		return "<a href='%s' style='%s'>%s</a>" % (path, style, name)

	def cnt(self, name, mode='inc', value=0):
		'''
			inc - увеличить
			dec - уменьшить
			+= - прибавить
			set - установить
		'''

		index = self.parent.counters_map[name]

		if mode == 'inc':
			with self.lock:
				self.parent.counters[index]['value'] += 1
		elif mode == 'dec':
			with self.lock:
				self.parent.counters[index]['value'] -= 1
		elif mode == '+=':
			with self.lock:
				self.parent.counters[index]['value'] += value
		elif mode == 'set':
			with self.lock:
				self.parent.counters[index]['value'] = value

		#self.parent._print(self.parent.counters[name]['name'] + str(self.parent.counters[name]['value']) )
		#~ if mode == 'inc':
			#~ sql = 'update _counters set value = value + 1 where name = "{0}"'.format(name)
		#~ elif mode == 'dec':
			#~ sql = 'update _counters set value = value - 1 where name = "{0}"'.format(name)
		#~ elif mode == '+=':
			#~ sql = 'update _counters set value = value + {0} where name = "{1}"'.format(int(value), name)
		#~ elif mode == 'set':
			#~ sql = 'update _counters set value = "{0}" where name = "{1}"'.format(int(value), name)
#~
		#~ self.parent.queue.addTask({'sql': 'exec', 'sql_cmd': sql, 'sql_id': 'update_sql'})

	def change_letters(text):

		replaces = {'й': 'и', 'Й': 'И', 'у': 'y', 'У': 'Y', 'к': 'k', 'К': 'K', 'е': 'e', 'Е': 'E', 'н': 'H', 'Н': 'H', 'х': 'x', 'Х': 'X', 'ы': 'bl', 'Ы': 'bl', 'в': 'B', 'В': 'B', 'а': 'a', 'А': 'A', 'р': 'p', 'Р': 'P', 'о': 'o', 'О': 'O', 'с': 'c', 'С': 'C', 'м': 'M', 'М': 'M', 'т': 'T', 'Т': 'T'}

		text_new = ''
		for letter in text:
			if hlp.rand(0, 1):
				if letter == ' ':
					letter = '  '
				else:
					letter = replaces.get(letter, letter)

			text_new += letter

		return text_new

	def randomize(text, change_letters=False):
		return hlp.rndmize(text, change_letters)

	def rndmize(text, change_letters=False):
		''' {1|2|{a|b|c}} '''
		# обработка {||}, замена букв на латинские аналоги

		elems = hlp.parse_all('{[^{}]+}', text)

		if elems is False:

			if change_letters:
				text = hlp.change_letters(text)

			return text

		for elem in elems:
			parts = elem.replace('{', '').replace('}', '').split('|')
			part = random.choice(parts)
			text = text.replace(elem, part)

		return hlp.rndmize(text)

	def find(patt, body):
		return bool(re.findall(patt, body))

	def size(filename):
		''' return size of a file in bytes '''

		if not os.path.exists(filename):
			print('hlp.size error: file not found!')

		return os.stat(filename)[6]

	def human_size(num):
		for x in ['байт','кб','мб','гб','тб']:
			if num < 1024.0:
				return "%3.1f %s" % (num, x)
			num /= 1024.0

	def human_date(timestamp=False, format_d="%d.%m.%y"):
		# http://docs.python.org/library/datetime.html#strftime-and-strptime-behavior
		import locale, time, os

		if os.name == 'posix':
			locale.setlocale(locale.LC_TIME, 'ru_RU.UTF-8')

		if timestamp is False:
			timestamp = time.time()

		from datetime import datetime
		d = datetime.fromtimestamp(float(timestamp))
		return d.strftime(format_d)

	def execute(command, silent=True):

		# proc = subprocess.Popen('mplayer /media/disk/audio/Oleg\ Skripka\ -\ SHedrik.mp3', shell=True, stdout=subprocess.PIPE, stdin=subprocess.PIPE).stdout.read()
		#device = open('/dev/null', 'w') if silent else subprocess.PIPE

		if silent:
			proc = subprocess.Popen(command, shell=True,
				stdout=subprocess.PIPE, stdin=subprocess.PIPE)
			processes = proc.stdout.read()
			return processes.decode('utf-8', 'ignore')
		else:
			proc = subprocess.Popen(command, shell=True,
				stdout=subprocess.PIPE, stdin=subprocess.PIPE)

		processes = b''
		while True:
			processes += proc.stdout.read(1024)

			if proc.poll() is not None:
				break

		ps = processes.decode('utf-8', 'ignore').split('\n')

		ps = [row.strip() for row in ps if row.strip()]

		if not ps:
			return []
		if len(ps) > 1:
			return ps
		else:
			return ps[0]


if __name__ == '__main__':


	page = '''f="?v=prl">Изменить ярлыки</a></td> </table> </td> <td valign="top"> <table width="100%" cellpadding="0" cellspacing="0" border="0"> <tr> <td width="5" bgcolor="#C3D9FF">&nbsp;</td> <td bgcolor="#e0ecff"> <form action="?v=b&fv=b&cpt=c&at=AF6bupON2I68igV2SK9WEHG8mPxYnyHshg&pv=tl&cs=c" name="f" enctype="multipart/form-data" method="POST"> <input type="hidden" name="redir" value="?"> <table width="100%" cellpadding="2" cellspacing="0" border="0" bgcolor="#C3D9FF"> <tr> <td> <input type="submit" name="nvp_bu_send" value="Отправить">&nbsp; <input type="submit" name="nvp_bu_sd" value="Сохранить черновик">&nbsp; <input type'''

	patterns = [r'form action="([^"]+)']
	params = hlp.parse(patterns, page)
	print(params)






