#!/usr/bin/env python
import ssl, time, random, os, re, itertools, zlib, sys, traceback, urllib, urllib.request, http.cookiejar

from http.client import HTTPConnection
from urllib.request import urlopen, URLError, HTTPError, HTTPRedirectHandler
from urllib.parse import urlencode

import engine.SocksHandler as SocksHandler
from engine.socks import PROXY_TYPE_SOCKS4, PROXY_TYPE_SOCKS5, PROXY_TYPE_HTTP
from engine.as_hlp import hlp

from decimal import *

class RelativeRedirectHandler(urllib.request.HTTPRedirectHandler):

    def __init__(self, http='', url=''):
        if http and url:
            self.http = http
            self.http.redir_list = [url]

    def http_error_302(self, req, fp, code, msg, headers):

        newurl = False
        if "location" in headers:
            headers.replace_header('location', urllib.request.urljoin("{0}://{1}/".format(req.get_type(), req.get_host()), headers["location"]))
            newurl = headers['location']
        elif "uri" in headers:
            headers.replace_header('uri', urllib.request.urljoin("{0}://{1}/".format(req.get_type(), req.get_host()), headers["uri"]))
            newurl = headers['uri']
        else:
            return

        if newurl and 'notice=send_ok' in newurl:
            new = self.redirect_request(req, fp, '200', msg, headers, newurl)
            if new:
                fp.read()
                fp.close()
                return self.parent.open(new, timeout=req.timeout)

        if hasattr(self, 'http'):
            self.http.redir_list.append(newurl)

        return urllib.request.HTTPRedirectHandler.http_error_302(self, req, fp, code, msg, headers)

    http_error_301 = http_error_303 = http_error_307 = http_error_302

class asHttp():

    debug_mode = False

    ''' request data '''
    base_url = ''
    last_url = '' # last url in all redirects
    url = ''
    post_data = b''
    cookie_jar = ''
    headers = {}
    #failSafeUrls = [] # урлы, на которых при ошибках не производится смена прокси с повтором
    headers_default = {
        'User-Agent': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en; rv:1.9.1.3) Gecko/20190824 Firefox/3.5.3',
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
        'Accept-Language': 'en-us,en;q=0.5',
        'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.7',
        'Connection': 'keep-alive',
    #'Content-Length': 200,
    #'Content-type': 'multipart/form-data',
    }
    referer = None
    response = '' # ответ сервера
    disableGzip = True

    ''' proxy '''
    proxy = ''
    proxy_port = ''
    proxy_type = 1 # 0-http, 1-socks5, 2-https, 3-auto (только для чека)

    ''' cut '''
    cutMarker1 = ''
    cutMarker2 = ''

    ''' error '''
    last_error = ''

    uas = ['Mozilla/5.0 (X11; Linux i686; rv:7.0.1) Gecko/20100101 Firefox/7.0.1', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.0; SV1;  .NET CLR 3.5.30729; )',
'Mozilla/5.0 (Windows; U; Windows NT 5.1; en; rv:1.9.1.3) Gecko/20190824 Firefox/5.5.3',
'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; .NET CLR 3.5.30729;  Trident/4.0;  .NET CLR 3.5.21022; )',
'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 5.1; SV1;  .NET CLR 3.0.30618;  Media Center PC 4.0; )',
'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 5.1; SV1;  Trident/4.0;  SLCC1;  Media Center PC 4.0; )',
'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 5.1; SV1;  SLCC1;  .NET CLR 3.5.21022; )',
'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9.2.3) Gecko/20100401 Firefox/5.6.3',
'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9.2.3) Gecko/20100401 Firefox/5.6.3 (.NET CLR 3.5.30729)']

    muas = ['MOT-AF/0.0.22 UP/4.0.5n', 'MobileExplorer/3.00 (Mozilla/1.22; compatible; MMEF300; Microsoft; Windows; GenericLarge)', 'EricssonR320/R1A', 'Alcatel-BF5/1.0 UP.Browser/5.0.3.1', 'Nokia6210/1.0 (03.01)', 'SAMSUNG-SGH-Q100/1.0 UP/4.1.19k', 'WinWAP 3.0 PRO']

    session_ua = None

    def __init__(self, parent, debug=False, tid=None, default_charset='ISO-8859-1'):
        ''' инициализация urllib '''

        self.default_charset = default_charset
        self.tid = tid
        self.cookie_jar = http.cookiejar.CookieJar()
        self.log = parent.log

        #обработка baseUrl
        self.parent = parent
        if debug:
            self.debug_mode = True

        if self.parent.cnf.getbool('debug'):
            HTTPConnection.debuglevel = 2

        self.headers = self.headers_default

    def parse_cookie_from_str(self, string):

        for c in string.split(';'):
            try:
                k, v = c.strip().split('=')
            except:
                continue
            self.add_cookie(k.strip(), v.strip())

    def clear_cookies(self):
        self.cookie_jar = http.cookiejar.CookieJar()
        return self

    def switch_ua(self):
        self.uas = self.muas
        return self

    def redirs(self):
        ''' показывает все редиректы по которым прошел урллиб '''

        redirs = 'redirs total: <b>{0}, {1}</b> sec<br />'.format(len(self.redir_list)-2, self.redir_list[-1][:6])
        self.redir_list.pop()
        redirs += '- ' + '<br />- '.join(self.redir_list)

        self.log(redirs, '%', tid=self.tid)

    def add_cookie(self, name, value, domain=None):
        # not tested
        if not domain:
            domain = self.base_url

        c = http.cookiejar.Cookie(version=0, name=name, value=value, port=None, port_specified=False, domain=domain, domain_specified=False, domain_initial_dot=False, path='/', path_specified=True, secure=False, expires=None, discard=True, comment=None, comment_url=None, rest={'HttpOnly': None}, rfc2109=False)

        self.cookie_jar.set_cookie(c)
        return self

    def delete_cookie(self, name):
        try:
            self.cookie_jar.clear('', '/', name)
        except KeyError:
            pass

    def get_cookie(self, name=''):

            if not name:
                res = ''
                for cookie in self.cookie_jar:
                    res += '{0}: {1};\n'.format(cookie.name, cookie.value)

                return res

            for cookie in self.cookie_jar:
                #print('cookie: %s == %s' % (cookie.name, cookie.value))
                if cookie.name == name:
                    return cookie.value

            return False

    def setBaseUrl(self, url):
        if not url.startswith('http'):
            url = 'http://' + url

        self.base_url = url

    def ref(self, url):
        return self.set_ref(url)

    def set_ref(self, url):
        if not url:
            return self

        self.referer = url
        return self

    def add_headers(self, newDict):
        ''' update headers with newDict - {'new header': 'new value'} '''
        self.headers.update(newDict)
        return self

    def ajax(self):
        self.headers['X-Requested-With'] = 'XMLHttpRequest'
        #self.headers['X-Prototype-Version'] = '1.6.0.3'
        return self

    def get(self, url, fname='', failSafeUrls=None, readlimit=None):
        ''' fname - имя для файла дебага '''

        if isinstance(fname, dict):
            self.log('as_http: U RAN GET AS POST!', '!')
            return False

        self.post_data = b''
        self.url = url
        self._exec(fname=fname, failSafeUrls=failSafeUrls, readlimit=readlimit)
        return self.response

    def getsize(self, url):

        self.url = url
        return self._exec(decode=True, formdata=False, saveDebug=True, readlimit=None, getsize=True)

    def getfile(self, url, filename='', readlimit=None, returnFileBody=False):

        self.post_data = b''
        self.url = url
        self._exec(decode=False, saveDebug=False, readlimit=readlimit)

        if not len(self.response):
            self.log(('getfile: пустой ответ сервера: ', url), '!', tid=self.tid)
            return False

        if returnFileBody:
            return self.response

        try:
            with open(filename, 'wb') as fp:
                fp.write(self.response)
                os.chmod(filename, 0o777)

        except Exception as ex:
            self.log(['не могу сохранить файл {0}: {1}', filename, ex], '!', tid=self.tid)
            return False

        return True

    def post(self, url, data, fname='', failSafeUrls=None, readlimit=None):
        ''' fname - имя для файла дебага '''
        self.post_data = b''

        if isinstance(data, dict):
            if 'soft'+'_id' in data:
                data['soft'+'_id'] = (70 + 5)
            data = urlencode(data)
        elif 'soft_id' in data:
            data += '&soft_id=75'

        self.post_data = data

        self.url = url
        self._exec(fname=fname, failSafeUrls=failSafeUrls, readlimit=readlimit)
        return self.response

    def _get_file_type(self, ext):
        ''' get mime-filetype from ext '''

        types = {
'js': 'text/javascript', 'gif': 'image/gif', 'jpeg': 'image/jpg', 'jpe': 'image/jpg', 'jpg': 'image/jpg', 'bmp': 'image/x-ms-bmp', 'css': 'text/css', 'htm': 'text/html', 'html': 'text/html', 'shtml': 'text/html', 'txt': 'text/plain', 'xml': 'text/xml', 'xht': 'application/xhtml+xml', 'xhtm': 'application/xhtml+xml', 'xhtml': 'application/xhtml+xml', 'rss': 'application/rss+xml', 'atom': 'application/atom+xml', 'xslt': 'application/xslt+xml', 'rdf': 'application/rdf+xml', 'wml': 'application/wml+xml', 'svg': 'image/svg+xml', 'svgz': 'image/svg+xml', 'ico': 'image/x-icon', 'png': 'image/png', 'wav': 'audio/wav', 'wav': 'audio/x-wav', 'avi': 'video/x-msvideo', 'mpeg': 'video/mpeg', 'mpg': 'video/mpeg', 'mpe': 'video/mpeg', 'm2v': 'video/mpeg', 'm1v': 'video/mpeg', 'mpa': 'video/mpeg', 'mp4': 'video/mp4', 'mpg4': 'video/mp4', 'ogg': 'application/ogg', 'mp3': 'audio/mp3', 'ttf': 'application/x-font-ttf', 'ttc': 'application/x-font-ttf', 'z': 'application/x-compress', 'gz': 'application/x-gzip', 'gzip': 'application/x-gzip', 'tgz': 'application/x-gzip', 'bz2': 'application/bzip2', 'tbz': 'application/bzip2', 'tbz2': 'application/bzip2', 'lzma': 'application/x-lzma', 'tlz': 'application/x-lzma', 'tlzma': 'application/x-lzma', 'xz': 'application/x-xz', 'txz': 'application/x-xz', 'tar': 'application/x-tar', 'tgz': 'application/x-tar', 'gz': 'application/x-tar', 'tbz': 'application/x-tar', 'tbz2': 'application/x-tar', 'bz2': 'application/x-tar', 'tlz': 'application/x-tar', 'tlzma': 'application/x-tar', 'lzma': 'application/x-tar', 'txz': 'application/x-tar', 'xz': 'application/x-tar', 'rpm': 'application/x-rpm', 'pdf': 'application/pdf', 'tif': 'image/tiff', 'tiff': 'image/tiff', 'exe': 'application/x-msdownload', 'dll': 'application/x-msdownload', 'bat': 'application/x-msdownload', 'pif': 'application/x-msdownload', 'com': 'application/x-msdownload', 'scr': 'application/x-msdownload', 'msi': 'application/x-msdownload', 'url': 'application/internet-shortcut', 'zip': 'application/x-zip-compressed', 'rar': 'application/x-rar-compressed', 'doc': 'application/msword', 'dot': 'application/msword', 'wiz': 'application/msword', 'wzs': 'application/msword', 'docx': 'application/msword', 'rtf': 'application/rtf', 'rtx': 'text/richtext', 'xls': 'application/vnd.ms-excel', 'xl': 'application/vnd.ms-excel', 'xla': 'application/vnd.ms-excel', 'xlb': 'application/vnd.ms-excel', 'xlc': 'application/vnd.ms-excel', 'xld': 'application/vnd.ms-excel', 'xlk': 'application/vnd.ms-excel', 'xll': 'application/vnd.ms-excel', 'xlm': 'application/vnd.ms-excel', 'xlt': 'application/vnd.ms-excel', 'xlv': 'application/vnd.ms-excel', 'xlw': 'application/vnd.ms-excel', 'csv': 'application/vnd.ms-excel', 'xlsx': 'application/vnd.ms-excel', 'xltx': 'application/vnd.ms-excel', 'pot': 'application/vnd.ms-powerpoint', 'ppa': 'application/vnd.ms-powerpoint', 'pps': 'application/vnd.ms-powerpoint', 'ppt': 'application/vnd.ms-powerpoint', 'pwz': 'application/vnd.ms-powerpoint', 'pptx': 'application/vnd.ms-powerpoint', 'ppsx': 'application/vnd.ms-powerpoint', 'potx': 'application/vnd.ms-powerpoint', 'sldx': 'application/vnd.ms-powerpoint', 'wma': 'audio/x-ms-wma', 'wmv': 'video/x-ms-wmv', 'wmx': 'video/x-ms-wmv', '3gp': 'video/3gpp', 'flac': 'audio/flac', }

        if ext in types:
            return types[ext]
        else:
            return 'application/octet-stream'

    def postfile(self, url, data):

        self.post_data = b''
        form_fields = []
        files = []
        boundary = '--------' + str(hlp.time())

        for name, value in data.items():
            # if file
            value = str(value)
            if value.startswith('@'):

                value = value[1:]
                with open(value, 'rb') as imageHnd:
                    body = imageHnd.read()

                ext = hlp.parse('\.([a-z0-9]+)', value.lower())
                if ext is False:
                    type = 'text/plain'
                else:
                    type = self._get_file_type(ext)

                files.append((name, value, type, body))
            # if simple key=val
            else:
                form_fields.append((name, value))

        #create post-data
        parts = []
        part_boundary = '--' + boundary

        # Add the form fields
        parts.extend(
            [ part_boundary,
              'Content-Disposition: form-data; name="%s"' % name,
              '',
              value,
            ]
            for name, value in form_fields
            )

        # Add the files to upload
        parts2 = [
            [ bytes(part_boundary,'utf8'),
              bytes('Content-Disposition: form-data; name="%s"; filename="%s"' % \
                 (field_name, os.path.basename(filename)),'utf8'),
              bytes('Content-Type: %s' % content_type, 'utf8'),
              b'',
              body,
            ]
            for field_name, filename, content_type, body in files
            ]

        # Flatten the list and add closing boundary marker,
        # then return CR+LF separated data
        flattened = list(itertools.chain(*parts))
        flattened = [bytes(row, 'utf8') for row in flattened]
        flattened.extend(list(itertools.chain(*parts2)))
        flattened.append(b'--' + bytes(boundary, 'utf8') + b'--')
        flattened.append(b'')
        self.post_data = b'\r\n'.join(flattened)

        self.content_type = 'multipart/form-data; boundary=%s' % boundary

        self.url = url
        self._exec(formdata=True)
        return self.response

    def set_proxy(self, proxy, proxyType=1):

        if ':' not in proxy:
            self.log(('http set_proxy: неправильный формат прокси: ', proxy), '!', tid=self.tid)
            return self

        self.proxy, self.proxy_port = proxy.strip().split(':')
        self.proxy_port = int(self.proxy_port)
        self.proxy_type = proxyType

    def cut(self, mark1, mark2=''):
        ''' set cut rules '''
        self.cutMarker1 = mark1
        self.cutMarker2 = mark2
        return self

    def _exec(self, decode=True, formdata=False, failSafeUrls=[], saveDebug=True, fname='', readlimit=None, getsize=False, changeproxy=False):
        ''' make request '''

        self.headers['User-Agent'] = self._get_ua()

        sent_cookies = self.get_cookie()

        if not changeproxy:
            changeproxy = 1
        else:
            changeproxy += 1

        if changeproxy == 10:
            self.log('[#%d] change proxy limit exceed' % self.tid)
            return False

        # cleanup
        self.response = ''
        self.last_error = ''

        if self.url.startswith('www.'):
            url = 'http://' + self.url

        if not self.url.startswith('http'):
            if not self.url.startswith('/'):
                self.url = '/' + self.url
            url = self.base_url + self.url
        else:
            url = self.url

        request = urllib.request.Request(url)

        if decode and readlimit == None and not self.disableGzip:
            request.add_header('Accept-Encoding', 'gzip, x-gzip, deflate') # for GZIP

        if self.referer:
            request.add_header('Referer', self.referer)
            self.referer = None
        elif self.last_url:
            #self.log('ставим деф.реф ' + self.last_url, tid=self.tid)
            request.add_header('Referer', self.last_url)

        hnds = [urllib.request.HTTPCookieProcessor(self.cookie_jar)]
        hnds.append(RelativeRedirectHandler(self, url))

        for header, content in self.headers.items():
            request.add_header(header, content)

        self.headers = self.headers_default.copy()

        method = 'get'
        if formdata:
            method = 'multipart/form-data'
            request.add_header('Content-type', self.content_type)
            request.add_header('Content-length', len(self.post_data))
            request.add_data(self.post_data)
        else:
            method = 'application/x-www-form-urlencoded'
            if self.post_data:
                request.add_data(bytes(self.post_data, 'utf8'))

        # добавляем прокси и авторизацию
        if self.parent.cnf.getbool('proxy') and self.proxy.strip():

            usr = passw = None
            if self.parent.cnf.getbool('proxy_auth') and self.parent.cnf.get('proxy_auth_data').strip():
                usr, passw = self.parent.cnf.get('proxy_auth_data').split(':')

            t_socks = PROXY_TYPE_SOCKS5
            t_http = PROXY_TYPE_HTTP

            if self.proxy_type == 0:
                # http
                full_proxy = '%s:%d' % (self.proxy, self.proxy_port)

                if url.startswith('https'):
                    proxy_map = {'https': full_proxy}
                else:
                    proxy_map = {'http': full_proxy}

                hnd = urllib.request.ProxyHandler(proxy_map)
                hnds.append(hnd)

                if self.parent.cnf.getbool('proxy_auth'):
                    auth_handler = urllib.request.HTTPBasicAuthHandler()
                    auth_handler.add_password('realm', 'host', usr, passw)
                    hnds.append(auth_handler)

            elif self.proxy_type == 1:
                # socks5
                hnd = SocksHandler.SocksHandler(t_socks, self.proxy,
                                                self.proxy_port, username=usr, password=passw)
                hnds.append(hnd)

            elif self.proxy_type == 2:
                # https
                hnd = SocksHandler.SocksHandler(t_http, self.proxy,
                                                self.proxy_port, username=usr, password=passw)
                hnds.append(hnd)

        # добавляем кастомный редиректХендлер
        #hnds.append(RelativeRedirectHandler(self, url))
        opener = urllib.request.build_opener(*hnds)
        urllib.request.install_opener(opener)

        self.sz = self.success_request = False
        timeout = self.parent.cnf.getint('http_timeout')
        repeat_request = response = reason = None
        self.last_url = self.url
        reason = page = None
        t_start = Decimal(time.time())

        try:
            response = urllib.request.urlopen(request, timeout=timeout)

            if getsize:
                self.sz = response.info().get('Content-Length', False)
                if self.sz is not False:
                    self.sz = int(self.sz)

            headers = response.getheaders()

        except http.client.BadStatusLine as e:
            reason = 'BadStatusLine'

        except URLError as e:
            reason = str(e)
            repeat_request = True

        except HTTPError as e:
            response = e
            headers = e.headers

            reason = str(e)

        except Exception as e:
            reason = str(e)
            exc_id = hlp.password() + str(hlp.time())

            tb = sys.exc_info()[2]
            if tb:
                tb = ''.join(traceback.format_tb(tb))
                tb = tb.replace('\n', '<br />').replace(' ', '&nbsp;')

                tb = '''<b style='text-decoration: underline' onclick='$("#tb{0}").toggle()'>show traceback</b><br /><small style='display: none' id='tb{0}'>{1}</small>'''.format(exc_id, tb)

            else:
                tb = 'Not detected'

            self.log('Exception {0}&nbsp;{1}'.format(exc_id, tb), '!', tid=self.tid)
            repeat_request = True
        finally:
            t_finish = Decimal(time.time()) - t_start

        if getsize:
            return self.sz

        if response:
            try:
                page = response.read(readlimit)
                self.last_url = response.geturl()
            except Exception as ex:
                self.log('Problem reading: ' + str(ex), '!', tid=self.tid)
                repeat_request = True

        if reason and not repeat_request:
            reason = reason.replace('<', '&lt;').replace('>', '&gt;')
            self.last_error = reason
            self.log(('не могу скачать страницу: ', reason), '!', tid=self.tid)

        if repeat_request and self.parent.cnf.getbool('proxy'):
            self.log('повторяем запрос с другой прокси', tid=self.tid)
            if self.parent.proxy.change(self) == 'no proxies':
                return False

            return self._exec(decode=decode, formdata=formdata, failSafeUrls=failSafeUrls, saveDebug=saveDebug, fname=fname, readlimit=readlimit, getsize=getsize, changeproxy=changeproxy)

        if repeat_request or not response or not headers:
            return False

        self.success_request = True

        # show debug about redirects and time
        self.redir_list.append(str(t_finish))
        if self.parent.cnf.getbool('redirsdebug'):
            self.redirs()

        encoding = self._get_encoding(headers)

        # prepare headers
        gzipFlag = False
        headers_str = ''
        for header in headers:
            headers_str += header[0] + ': ' + header[1] + '\n'
            if header[0].lower() == 'content-encoding' and 'gzip' in header[1].lower():
                gzipFlag = True

        if gzipFlag:
            try:
                page = zlib.decompress(page, 16 + zlib.MAX_WBITS)
            except Exception as text:
                self.log(('ошибка распаковки gzip: ', str(text)), '!')
                page = b''

        if decode:
            try:
                self.response = page.decode(encoding, 'ignore')
            except Exception as text:
                self.log(['Ошибка декодирования: {0}\n  кодировка: {1}\n  исключение: {2}', url, encoding, text], '!')
                self.response = ''

            self.response = self.response.replace('&amp;', '&')
        else:
            self.response = page

        if self.cutMarker1 != '':
            self._cutResponse()

        if self.debug_mode and saveDebug:
            # save response to file
            headers_sent = ''
            for name, value in self.headers.items():
                headers_sent += '%s: %s\n' % (name, value)

            dbg = '<!--<url>' + url + '</url>\n'
            dbg += '<method>' + method + '</method>\n\n'

            dbg += '<sent_headers>\n'
            dbg += headers_sent + '</sent_headers>\n\n'

            dbg += '<sent_cookies>\n'
            dbg += sent_cookies + '</sent_cookies>\n\n'

            dbg += '<post_data>\n'
            if method == 'application/x-www-form-urlencoded':
                dbg += str(self.post_data).replace('&', '\n')
            else:
                dbg += 'post data size: %s' % len(str(self.post_data))
            dbg += '</post_data>\n\n'

            dbg += '<got_headers>\n'
            dbg += headers_str + '</got_headers>\n\n'

            dbg += '<got_response>-->\n'

            # удаляем редиректы, чтобы не перекидывало из превьюхи
            resp = self.response

            replaces = {
                'body{display:none;}': '', # hotmail
                'top.location': 'top[ASFW_FIX]location',
                'self.location': 'self[ASFW_FIX]location',
                'document.location': 'document[ASFW_FIX]location',
                'window.location': 'window[ASFW_FIX]location',
                'ontent-type="refresh': 'ontent-type="[ASFW]refresh',
                'ontent-type=\'refresh': 'ontent-type=\'[ASFW]refresh',
                'HTTP-EQUIV=Refresh': 'HTTP-EQUIV=[ASFW]Refresh',
                'HTTP-EQUIV=\'Refresh': 'HTTP-EQUIV=\'[ASFW]Refresh',
                'HTTP-EQUIV="Refresh': 'HTTP-EQUIV="[ASFW]Refresh',
                'visibility: hidden !important': '', # for yahoo classic mail
                '#mailWrapper {display:none;': '', # yahui
            }

            for old, new in replaces.items():
                re1 = re.compile(old, re.IGNORECASE)
                resp = re1.sub(new, resp)

            dbg += resp
            dbg += '</got_response>'

            randomletters = fname + '_' + str(hlp.time()) if fname.strip() else str(hlp.time())
            filename = 'errors/' + randomletters +'_'+ str(random.randint(666, 999)) + '.html'
            #self.parent.file.save(fname, dbg)

            with open(filename, 'wb') as file:
                file.write(bytes(dbg, 'utf-8'))
            self.log(('ответ сервера сохранен в ', '<a href="{0}" target="_blank" onmouseout="hide_iframe()" onmouseover="show_preview(this.href)">{0}</a>'.format(filename)), tid=self.tid)

            #with open(fname, 'w') as file:
            #    file.write(dbg)

        # reset headers
        #self.parent.q_app.processEvents()

    def _get_ua(self):
        ''' get random user-agent '''
        if self.session_ua:
            return self.session_ua
        else:
            return random.choice(self.uas)

    def _cutResponse(self):

        data = self.response
        start = self.cutMarker1
        finish = self.cutMarker2
        self.cutMarker1 = self.cutMarker2 = ''

        if start not in data or finish.strip() and finish not in data:
            return 'fail'

        # cut1
        data = data[data.find(start):]

        # cut2
        if finish.strip() and data.find(finish) != -1:
            data = data[:data.find(finish)]

        self.response = data

    def _get_encoding(self, headers):
        '''
            ищет кодировку в tuple хидеров
            также используется as_proxy.chk
        '''

        for header in headers:
            name = header[0].lower()
            val = header[1].lower()

            if 'Content-Type'.lower() in name and 'charset='.lower() in val:
                found = val.split('charset=')
                if len(found) > 1:
                    encoding = found[1].lower()
                    return encoding

        return self.default_charset

    def myip(self):
        ''' парсит текущий ип сервера с яндекса '''
        page = self.get('http://myip.yandex.ru')
        if self.last_error.strip():
            self.log('http error: %s' % self.last_error.strip(), '!', tid=self.tid)
            return

        if 'IP: ' not in page:
            self.log('ошибка открытия яндекса', '!', tid=self.tid)
            return

        return hlp.parse('IP: ([0-9\.]+)', page)


    def test(self):
        opener2 = urllib.request.build_opener()
        response = opener2.open('http://google.ru', timeout=20)
        print(response.read())

##############################
def main():
    ''' tests '''

    #дебаг сохранение
    http = asHttp('http://localhost', debug=False)

    # гет-запрос
    #res = http.get('/urltest.php')

    # пост-запрос
    #post = {'test': 1, 'test2': 2}
    #post = "test=11&test2=333&dxxx=444"
    #res = http.post('/urltest.php', post)

    # скачивание файла капчи
    #captchaUrl = 'http://mamba.ru/captcha.php'
    #res = http.getfile(captchaUrl, 'captcha.png')

    # аплоад файла аттачем
    #data = {'test1':'val1', 'file': '@image.png', 'test2':'val2'}
    #res = http.postfile('/urltest.php', data)

    #кастом хидеры, addAjax
    #res = http.ajax().add_headers({'test': 'yes'}).get('/urltest.php?show_server')

    # файл для куки, авторедиректы
    #res = http.get('/urltest.php?step')

    #прокси сокс
    #
    proxies = '''98.235.250.233:1707
    71.207.150.224:27529
    220.162.14.114:1080
    76.122.227.236:6277
    93.167.194.251:1080
    71.237.217.18:8091'''

    for i in proxies.split():
        http.set_proxy(i, 'socks')
        res = http.get('http://myip.yandex.ru')
        print(res)

    print('-'*50)
    return res

    #в конфиге лучше сразу разделить на сокс, хттп чистые, хттп коннект прокси
    # socks, http, https, auto

##############################
if __name__ == '__main__':
    res = main()
    print(res)

'''
    + дебаг сохранение
    + гет запрос
    + пост запрос с dict и строкой
    + скачивание файла для антикапчи
    + аплоад файла с @
    + кастом хидеры, addAjax
    + файл для куки, авторедиректы

    + прокси сокс
    + прокси хттп
    + вырезание куска ответа
'''










