import random, sys, time, urllib
from http.client import HTTPConnection
from threading import Thread
from urllib import request
from urllib.request import urlopen, URLError, HTTPError

import engine.SocksHandler as SocksHandler
from engine.socks import PROXY_TYPE_SOCKS4, PROXY_TYPE_SOCKS5, PROXY_TYPE_HTTP
from engine.as_hlp import hlp
from engine.as_sqlite import asSqlite
from engine.as_sqlite import asSqlite_deferred

class asProxy():

	last_type = 0 # нужен для работы типа auto (перебор всех типов прокси) в self.chk
	last_valid_proxy = ''
	type_codes = {0: 'http', 1: 'socks5', 2: 'https', 3: 'auto'}
	used_proxies = [] # использованные прокси для подсчета сколько раз использована одна прокси разными потоками (бэкконект игнорится)

	def __init__(self, parent):
		self.parent = parent
		self.cnf = self.parent.cnf
		self.sqlite = self.parent.sqlite
		self.sqlite_def = self.parent.sqlite_def
		self.log = self.parent.log
		self.last_download_count = 0 # сколько прокси скачали с урла последний раз

	# proxy_url, proxy_minimum_required, proxy_load_url_tries
	# откуда грузить, сколько процентов минимум требуется, сколько попыток скачивания делать
	def w_autoupdate(self, url, min_required, load_tries, is_thread=True):

		while True:
			# если с урла не удалось скачать
			if self.parent.sqlite_storage['proxy'] and self.parent.sqlite_storage['proxy'][0] == 'URL_FAIL':
				self.parent.threadsStopped.set()
				return

			if self.parent.threadsStopped.is_set():
				return

			now_len = len(self.parent.sqlite_storage['proxy'])
			need_proxies = (self.last_download_count/100) * min_required
			need_proxies = int(need_proxies)

			# если нет прокси ИЛИ скачанных 0 ИЛИ сейчас < сколько_требуется
			if not now_len or self.last_download_count == 0 or now_len < need_proxies:
				# качаем
				if not load_tries:
					load_tries = 1

				for i in range(load_tries):

					proxies = self.parse_url(url)
					if len(proxies):
						break
					else:
						time.sleep(5)

				# если скачали
				new_len = len(proxies)
				if new_len:
					self.parent.sqlite_storage['proxy'] = proxies
					self.last_download_count = new_len
					self.log(['обновили список прокси до {0} штук', new_len])
				else:
					# если не скачали
					self.parent.sqlite_storage['proxy'] = ['URL_FAIL']
					self.last_download_count = 0
					self.parent.threadsStopped.set()
					return

			if not is_thread:
				return

			# спим
			for i in range(5):
				if self.parent.threadsStopped.is_set():
					break
				time.sleep(1)

	def parse_url(self, url):
		''' парсит прокси с урла url, возвращает список '''

		page = self.parent.http.get(url)

		if self.parent.http.last_error:
			self.log(['ошибка скачивания прокси: {0}', self.parent.http.last_error], '!')
			return []

		part1 = hlp.parse_all(hlp.PATTERN_PROXY, page)

		part2 = hlp.parse_all(hlp.PATTERN_PROXY_2, page)

		if part1 is False:
			part1 = []

		if part2 is False:
			part2 = []

		proxies = list(set(part1 + part2))

		if not len(proxies):
			self.log('не найдены прокси по ссылке', '!')
			return []
		else:
			self.log(['загружено {0} прокси', len(proxies)], '+')

		return proxies

	def load(self):

		if not self.cnf.getbool('proxy'):
			return

		if self.cnf.getbool('proxy_src_url'):
			self.parent.sqlite_storage['proxy'] = []
			url = self.cnf.get('proxy_url')

			if not url.strip():
				self.log('включена загрузка прокси с урла, но урл не указан', '!')
				sys.exit(0)

			# вызываем 1 раз перед началом работы
			self.w_autoupdate(url, self.cnf.getint('proxy_minimum_required'), self.cnf.getint('proxy_load_url_tries'), is_thread=False)

			#~ self.log('ждем пока прокси загрузятся с урла')
#~
			#~ for i in range(10):
				#~ l_proxy = len(self.parent.sqlite_storage['proxy'])
				#~ self.log(['сейчас {0} прокси', l_proxy])
#~
				#~ if l_proxy:
					#~ self.log(['получили {0}', l_proxy])
					#~ break
				#~ else:
					#~ hlp.slp(self.log, 1)

			sz = len(self.parent.sqlite_storage['proxy'])
			if sz == 1 and self.parent.sqlite_storage['proxy'][0] == 'URL_FAIL':
				sz = 0

		# если берем из БД
		else:
			self.parent.sqlite_storage['proxy'] = self.sqlite.getlist('proxy', unique=False, what='data, type')
			sz = len(self.parent.sqlite_storage['proxy'])

		if not sz:
			self.log('нет прокси в БД', '!')
			sys.exit(0)
		else:
			self.log(['в БД {0} прокси', sz], '+')

		#запуск потока автообновления
		if self.cnf.getbool('proxy_src_url'):

			c_url = self.cnf.get('proxy_url')
			self.log(['запускаем поток для автоматического обновления списка прокси с урла <b>{0}</b>', c_url])
			t = Thread(target=self.w_autoupdate, args=(self.cnf.get('proxy_url'), self.cnf.getint('proxy_minimum_required'), self.cnf.getint('proxy_load_url_tries')))
			t.start()


	def chk(self, proxy, type_code, tid=0):
		'''
			принимает прокси, код (0: 'http', 1: 'socks5', 2: 'https', 3: 'auto')
			возвращает True/False
		'''

		type_code = int(type_code)

		if self.cnf.chk('proxy_use_fast_socks_check') and type_code == 1 and self.cnf.getbool('proxy_backconnect') and self.cnf.getbool('proxy_use_fast_socks_check'):
			import socket

			ip, port = proxy.split(':')
			s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

			try:
				s.settimeout(5)
				s.connect((ip, int(port)))
				s.send(b'GET http://google.ru')
				response = b''
				while True:
					d = s.recv(4096)
					response += d
					if not d:
						break

				if 'Error' in str(response):
					return True
				else:
					return False

			except Exception as ex:
				return False
			finally:
				s.close()

			return False


		url = self.cnf.get('proxy_check_url')
		text = self.cnf.get('proxy_check_text')

		if self.parent.queue.events['stop_right_there'].is_set():
			return 'stop_all'

		if ':' not in proxy:
			self.log('invalid proxy format: ' + str(proxy), '!', tid=tid)
			return False

		self.log(['проверяем {0}, тип {1}', proxy, self._get_proxy_type(type_code)], tid=tid)
		self.last_type = ''
		self.last_response = ''

		usr = passw = None
		if self.cnf.getbool('proxy_auth') and self.cnf.get('proxy_auth_data').strip():
			usr, passw = self.cnf.get('proxy_auth_data').split(':')

		ip, port = proxy.split(':')
		port = int(port)

		t_socks = PROXY_TYPE_SOCKS5
		t_http = PROXY_TYPE_HTTP

		hnds = []

		request = urllib.request.Request(url)
		#request.add_header('Accept-Encoding', 'gzip, x-gzip, deflate')
		request.add_header('User-Agent',
						'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.1.3) Gecko/20190824 Firefox/3.5.3')

		if type_code == 0:
			# проверяем как http
			self.last_type = 0

			if url.startswith('https'):
				proxy_map = {'https': proxy}
			else:
				proxy_map = {'http': proxy}

			hnd = urllib.request.ProxyHandler(proxy_map)
			hnds.append(hnd)

			if self.cnf.getbool('proxy_auth'):
				auth_handler = urllib.request.HTTPBasicAuthHandler()
				auth_handler.add_password('realm', 'host', usr, passw)
				hnds.append(auth_handler)

		elif type_code == 1:
			# проверяем как socks5
			self.last_type = 1
			hnd = SocksHandler.SocksHandler(t_socks, ip, port, username=usr, password=passw)
			hnds = [hnd]

		elif type_code == 2:
			# проверяем как https
			self.last_type = 2

			hnd = SocksHandler.SocksHandler(t_http, ip, port, username=usr, password=passw)
			hnds = [hnd]

		elif type_code == 3:
			# проверяем как auto
			# сначала проверяем как http, потом socks5, потом https

			if self.chk(proxy, 0):
				self.last_type = 0
				return True

			if self.chk(proxy, 1):
				self.last_type = 1
				return True

			if self.chk(proxy, 2):
				self.last_type = 2
				return True

			self.last_type = ''
			return False

		opener = urllib.request.build_opener(*hnds)
		urllib.request.install_opener(opener)

		try:
			res = urllib.request.urlopen(request,
						timeout=self.parent.cnf.getint('proxy_timeout'))
		except HTTPError as e:
			self.log(('сервер вернул ошибку: ', str(e.code)), '!', tid=tid)
			return False
		except URLError as e:
			self.log(('не могу скачать страницу: ', str(e.reason)), '!', tid=tid)
			return False
		except Exception as e:
			self.log(('ошибка: ', str(e)), '!', tid=tid)
		else:
			headers = res.getheaders()
			encoding = self.parent.http._get_encoding(headers)

			try:
				data = res.read().decode(encoding, 'ignore')
			except Exception as e:
				self.log(('ошибка http.read().decode(): ', str(e)), '!', tid=tid)
				return False

			if text in data:
				self.last_response = data
				return True
			else:
				return False

		return False


	def change(self, http):

		if not self.cnf.getbool('proxy'):
			return False

		# если берем прокси с урла
		if self.cnf.getbool('proxy_src_url'):

			if not self.parent.sqlite_storage['proxy'] or self.parent.sqlite_storage['proxy'][0] == 'URL_FAIL':
				return 'no proxies'

			type_code = self.cnf.getint('proxy_url_type')

			# подбираем прокси
			while True:

				if not self.parent.sqlite_storage['proxy']:
					return 'no proxies'

				# выбираем
				proxy = hlp.rand(self.parent.sqlite_storage['proxy'])

				# чекаем
				if self.chk(proxy, type_code, http.tid):
					self.log(['ставим {0}, тип {1}', proxy, self._get_proxy_type(type_code)], '+', tid=http.tid)
					http.set_proxy(proxy, type_code)
					return

				else:
					self.log(['прокси {0} дохлая', proxy], '-', tid=http.tid)
					if not self.cnf.getbool('proxy_backconnect'):
						if proxy in self.parent.sqlite_storage['proxy']:
							self.parent.sqlite_storage['proxy'].remove(proxy)


		# если берем прокси из БД
		else:

			# подбираем прокси
			while True:

				if not self.sqlite_def.sz('proxy'):
					return 'no proxies'

				# выбираем
				proxy_map  = hlp.rand(self.parent.sqlite_storage['proxy'])
				proxy, type_code = proxy_map

				if proxy is False:
					self.log('as_proxy: get rand fail', '!', tid=http.tid)
					return 'no proxies'

				# чекаем
				if self.chk(proxy, type_code, http.tid):
					self.log(['ставим {0}, тип {1}', proxy, self._get_proxy_type(type_code)], '+', tid=http.tid)
					http.set_proxy(proxy, type_code)
					return

				else:
					self.log(['прокси {0} дохлая', proxy], '-', tid=http.tid)
					if not self.cnf.getbool('proxy_backconnect'):
						self.sqlite_def.rm('proxy', proxy)


	def _get_proxy_type(self, typeCode):
		types = ['http', 'socks5', 'https', 'auto']
		return types[typeCode]






