#from PyQt4 import QtGui, QtCore
from engine.as_gui import asGui

class asSubWindow(asGui):
    
    def __init__(self, parent, title, width=320, height=240):
        QtGui.QWidget.__init__(self)
        self.parent = parent
        self.setWindowTitle(title)                
        self.resize(width, height)
        self.ui = t()
        
    def label(self, name, title, left, top, width=50, height=20):
        setattr(self.ui, 'label_' + name, QtGui.QLabel(self))
        obj = getattr(self.ui, 'label_' + name)
        obj.setGeometry(QtCore.QRect(left, top, width, height))
        if title:
            obj.setText(title + ':')
    
    def line(self, name, left, top, width=200, height=25, value=''):
        setattr(self.ui, 'lineEdit_' + name, QtGui.QLineEdit(self))
        obj = getattr(self.ui, 'lineEdit_' + name)       
        obj.setGeometry(QtCore.QRect(left, top, width, height))
        obj.setText(value)    
        
    def button(self, name, title, left, top, width=120, height=25, action=''):

        setattr(self.ui, 'pushButton_' + name, QtGui.QPushButton(self))
        obj = getattr(self.ui, 'pushButton_' + name)           
        obj.setGeometry(QtCore.QRect(left, top, width, height))
        obj.setText(title)
        if action:        
            self.connect(obj, QtCore.SIGNAL('clicked()'), getattr(self.parent, action))            
        
    def drawForm(self, fields):
        
        top = 20
        for row in fields:
            left = 10
            for elem in row:
                if elem['t'] == 'nbsp':
                    self.label('', '', left, top)                
                elif elem['t'] == 'label':
                    self.label(elem['n'], elem['tl'], left, top)
                elif elem['t'] == 'line':
                    value = elem['value'] if 'value' in elem else ''
                    self.line(elem['n'], left, top, value=value)
                elif elem['t'] == 'button':
                    action = elem['action'] if 'action' in elem else ''                    
                    self.button(elem['n'], elem['tl'], left, top, action=action)
                left += 70
            top += 30
        
                    
if __name__ == '__main__':
    
    class myApp(QtGui.QApplication):
        
        def __init__(self):
            QtGui.QApplication.__init__(self, [])
                   
            
        def addUser(self):
            self.v = Form(self, "Добавить аккаунт", 320, 180)
            
            fields = [
                [{'t':'label', 'n':'nick', 'tl':'ник'}, {'t':'line', 'n':'nick', 'value': 'test nick'}],
                [{'t':'label', 'n':'icq', 'tl':'icq'}, {'t':'line', 'n':'icq', 'value': 'test icq'}],
                [{'t':'label', 'n':'email', 'tl':'email'}, {'t':'line', 'n':'email', 'value':'test'}],
                [{'t':'nbsp'}, {'t':'button', 'n':'add', 'tl':'Добавить', 'action':'addUser_exec'}],
                [{'t':'nbsp'}, {'t':'button', 'n':'print', 'tl':'print!', 'action': 'addUser_print'}],
            ]
            
            self.v.drawForm(fields)    
            self.v.show()
            
        def addUser_exec(self):
            nick = self.v.lineEdit('nick')
            print(nick)
            self.v.close()
            
        def addUser_print(self):
            nick = self.v.lineEdit('nick')
            icq = self.v.lineEdit('icq')
            email = self.v.lineEdit('email')
            print('nick:', nick, 'icq:', icq, 'email:', email)
    
    
    app = myApp()
    app.addUser()
    app.exec_()
    