#!/usr/local/bin/python3

import sys, os, cgi, random, re
sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n')
os.dup2(1, 2)

from as_hlp import hlp

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

form = cgi.FieldStorage()

if not 'file' in form:
	_print('файл не найден')
	sys.exit(0)

log_name = '../%s' % form.getvalue('file').strip()
log_name = log_name.replace('../../', '../')

if not os.path.exists(log_name):
	_print('файл не найден: %s' % log_name)
	sys.exit(0)

cmd = form.getvalue('cmd') if 'cmd' in form else 'main'

_print('''	<style type='text/css'>
	* {
		font-family: Verdana;
		font-size: 10pt;
		background-color: #eee;
	}
	</style>''')


######################################### LEFT

if cmd == 'search':

	find = form.getvalue('searchtext') if 'searchtext' in form else ''
	_print('Ищем текст: <b>%s</b><br />' % find)

	bash = "export LC_ALL=ru_RU.UTF-8 && export LANG=ru_RU.UTF-8 && grep --binary-files=text \"%s\" %s" % (find, log_name)
	_print('<script src="../res/jquery-1.6.2.min.js"></script>')

	rows = hlp.execute(bash, silent=False)
	for i, row in enumerate(rows):
		_print(row)

if cmd == 'index':
	from as_hlp import hlp

	_print('''
	<form target='logbody' method='get'>
	<input type='hidden' name='cmd' value='search' />
	<input type='hidden' name='file' value='%(log_name)s' />
	<input type='text' name='searchtext' size='5' /><input type='submit' style='background-color: #eee' value='Поиск' />
	</form>
	''' % globals())

	bash = "grep --binary-files=text -Po '(?<=threadid=\"#)\d+' %s" % log_name
	tids = hlp.execute(bash, silent=False)

	tids_d = {}
	for tid in tids:
		tids_d[int(tid)] = int(tid)

	_print('''	<style type="text/css">
			* {
				background-color: #fff;
			}
			</style>''')
	#tids = sorted(list(set(tids)))
	for tid in sorted(tids_d.keys()):
		_print('<a target="logbody" href="log_viewer.py?cmd=log&file=%(log_name)s&tid=%(tid)s">%(tid)s</a><br />' % globals())

	sys.exit(0)


######################################### SHOW LOG

if cmd == 'log':

	from as_hlp import hlp

	sz = os.stat(log_name)[6]

	if 'tid' in form or sz > 2000000:

		if sz > 2000000 and 'tid' not in form:
			tid = 0
		else:
			tid = form.getvalue('tid')

		bash = 'grep --binary-files=text \'threadid=\"#%s\"\' %s' % (tid, log_name)

		log = hlp.execute(bash, silent=False)
		_print('''
		<style type="text/css">
			BODY {background-color: #fff; }
			#preview_html {
				z-index: 999999;
				position: fixed;
				top: 10px;
				right: 10px;
				border: 1px solid black;
				width: 650px;
				height: 550px;
				overflow: scroll;
				display: none;
			}
		</style>
		<script src="../res/jquery-1.6.2.min.js"></script>
		<script src="../res/interface.js"></script><iframe id="preview_html"></iframe>
		''')

		for row in log:
			_print(row.replace('href="errors/', 'href="../errors/').replace('="tmp/', '="../tmp/'))

	else:
		_print('''<style type="text/css">
			* {
				background-color: #fff;
			}
			</style>
			<script src="../res/jquery-1.6.2.min.js"></script>
			<script src="../res/interface.js"></script>''')
		with open(log_name, 'rb') as fp:
			log_body = fp.read().decode('utf-8', 'ignore')#[:10000]
			_print(log_body.replace('href="errors/', 'href="../errors/'))

	sys.exit(0)

#########################################  MAIN FRAMES

if cmd == 'main':

	try:
		parts = re.findall(r'tmp/([0-9]+).([0-9]+)_([0-9]+):([0-9]+):([0-9]+)_log', log_name)[0]
		months = {
			'01':'января',
			'02':'февраля',
			'03':'марта',
			'04':'апреля',
			'05':'мая',
			'06':'июня',
			'07':'июля',
			'08':'августа',
			'09':'сентября',
			'10':'октября',
			'11':'ноября',
			'12':'декабря',
		}
		formatted_name = '%s %s, %s:%s:%s' % (parts[0], months[parts[1]], parts[2], parts[3], parts[4])
	except:
		formatted_name = log_name

	size_mb = hlp.human_size(os.stat(log_name)[6])
	#round(os.stat(log_name)[6] / 1024, 2)

	_print('''

	<table border='0' width='100%%' height='100%%'>
	<tr style='height: 20px'><td colspan='2' style='text-align: center'>
		<a href='../cp.py?cmd=logs'>&laquo; назад</a>&nbsp;&nbsp;&nbsp;лог от %(formatted_name)s. Размер %(size_mb)s
	</td></tr>
	<tr valign='top'>
		<td width='150' style='border: 1px solid black'>
		<iframe style='border: 0' src='log_viewer.py?cmd=index&file=%(log_name)s' width='100%%'  height='100%%'></iframe>
		</td>

		<td style='border: 1px solid black'>
		<iframe style='border: 0' name='logbody' src='log_viewer.py?cmd=log&file=%(log_name)s' width='100%%'  height='100%%'></iframe>
		</td>
	</tr>
	</table>
	''' % globals())

