#!/usr/local/bin/python3
import sys, os, cgi, cgitb, re
from engine.as_sqlite import asSqlite
from engine.as_hlp import hlp
from engine.config_editor_class import Config

os.dup2(1, 2)

form = cgi.FieldStorage()

EXPORT = False

if 'exporttype' in form and form.getvalue('exporttype') == 'plain' and 'table' in form:

	EXPORT = True

else:
	sys.stdout.buffer.write(b'Content-type: text/html;charset=utf-8\n\n<html><head><title>Resource Editor</title><script src="res/jquery-1.6.2.min.js"></script></head><body>')

def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

if 'cnf_id' in form:
	cnf_id = form.getvalue('cnf_id')
	cnf_text = '?cnf_id=' + cnf_id
else:
	cnf_id = False
	cnf_text = ''

cnf_path = 'config.ini' if not cnf_id else 'configs/%s/config.ini' % cnf_id

cnf = Config(cnf_path)
cnf.parseLang()

cnf_text2 = cnf_text.replace('?', '')
db_path = 'data.db' if not cnf_id else 'configs/%s/data.db' % cnf_id

if not os.access('data.db', os.W_OK):
	print('Sorry, database <b>"%s"</b> is readonly! Make "chmod 777 %s"' % (db_path,db_path))
	sys.exit(0)

sql = asSqlite(dbpath=db_path)
sql.debug = False

if EXPORT:
	data = sql.getlist(form.getvalue('table'))
	data = '\n'.join(data)

	headers = 'Content-Type: application/x-force-download; name=export.txt\nContent-Disposition: attachment; filename=exported_table_%s.txt\nExpires: Mon, 28 Jul 1997 05:00:00 GMT\nAccept-Ranges: bytes\nCache-control: private\nPragma: private\nContent-Length: %s\n\n' % (form.getvalue('table'), len(data))

	sys.stdout.buffer.write(bytes(headers, 'utf-8'))
	sys.stdout.buffer.write(bytes(data, 'utf-8'))

	sys.exit(0)

accs_schema = sql.exec("select sql from sqlite_master where name='accounts';")

class getData:

	def main_get(self, form):

		data = ''
		# проверяем пришел ли аттач
		if 'newfile' in form:
			data = form.getvalue('newfile').decode('utf-8', 'ignore')

		# проверяем пришел ли локальный файл
		if 'local_name' in form:
			local_name = form.getvalue('local_name')
			if not os.path.exists(local_name):
				_print('<div id="err">' +local_name +' '+t('файл не найден')+ '</div>')
				sys.exit(0)

			# распаковываем зип
			if local_name.lower().endswith('.zip'):
				local_name = self.unzip(local_name)

			with open(local_name, 'rb') as fp:
				data = fp.read().decode('utf-8', 'ignore')

		# проверяем пришел ли текст
		if 'newdata' in form:
			data = form.getvalue('newdata')

		# обработка
		data = self.process_data(data)

		if data:
			_print('<div id="ok">' + str(len(data)) +' '+ t('строк загружено')+ '</div>')
		else:
			_print('<div id="err">0 ' +t('строк загружено')+ '</div>')
			sys.exit(0)

		return data

	def process_data(self, data):

		#удаляем пустые строки
		#обрезаем переводы строк
		#hlp.quote()

		new = [hlp.quote(row.strip()) for row in data.split('\n') if row.strip()]
		return new

	def unzip(self, local_name):
		hlp.execute('unzip -o ' + local_name)
		return local_name[:-4]

	def get_sql(self, sql, table):
		return 'insert or ignore into %s values(%s)' % (table, sql.table_cols[table].replace("'%s'", '?'))


def _print(text):
	sys.stdout.buffer.write(text.encode('utf8'))
	sys.stdout.flush()

if os.path.exists('res/lang'):
	LANG = 'ENG'
else:
	LANG = 'RUS'

def t(text):

	if LANG == 'RUS':
		return text

	words = {
		'создать индекс': 'create index',
		'удалить индекс': 'delete index',
		'неизв. сервер': 'unknown server',
		'аккаунты': 'accounts',
		'прокси': 'proxies',
		'удалить дубли': 'delete duplicates',
		'удалить невалид': 'delete invalid',
		'очистить': 'clear',
		'экспорт': 'export',
		'удалить проспамленных': 'delete spammed',
		'удалить неподтвержденных': 'delete not-confirmed',
		'удалить с неизв. доменом': 'delete unknown domain',
		'удалить с пустым КЛ': 'delete empty CL',
		'удалить с ошибкой отправки': 'delete sent error',
		'удалить завершивших': 'delete finished',
		'удалить валидные': 'delete valid',
		'<b>очистить кеш acc_id</b>': 'clear acc_id cache',
		'<b>удалить все флаги</b> (проспам, невалид, ...)': '<b>delete all flags (spammed,invalid,etc)</b>',
		'удалить флаги с требующих подтверждение': 'delete flags from require confirm',
		'добавить данные': 'add data',
		'всего': 'total',
		'не начинали': 'not started',
		'не закончили': 'not finished',
		'закончили': 'finished',
		'валид': 'valid',
		'невалид': 'invalid',
		'добавить': 'add',
		'пустой КЛ': 'empty CL',
		'или добавить через поле': 'or add text to field',
		'имейлы из КЛ': 'emails from CL',
		'проспам': 'spammed',
		'неспам': 'not spammed',
		'получатели': 'recipients',
		'ошибка отпр.': 'sent error',
		'Статистика': 'Statistics',
		'Локальный файл': 'Import local file',
		'Загрузить файл': 'Upload a file',
		'и': 'and',
		'данные': 'data',
		'очистить выделенные': 'clear selected',
		'смотреть': 'view',
		'выход': 'back',
		'таблица': 'table',
		'сохранить': 'save',
		'тестер сообщений': 'message preview',
		'SQL': 'SQL',
		'Неправильный запрос': 'Invalid query',
		'Результаты запроса': 'Query results',
		'Запрос к БД': 'Query',
		'язык': 'language',
		'строк загружено': 'rows added',
		'выполнено': 'done',
	}

	if text in words:
		return words[text]
	else:
		return text

_print('''
<script>

// :not(#menuBlock) :not(img)

//$('body > *:not(div#do-not-modify-me)')

//$("body:not(#menuBlock)").bind("click",funсtion() {$("#menuBlock").hide();});
// body > *:not(#menuBlock)
/*
$(document).ready(function() {

	$(":not(img)").bind("click", function(){
		//alert('0000')
		if($('#menuBlock').is(":visible"))
			//$('#menuBlock').hide()
			alert(111)
	});

});
*/
</script>
<style type='text/css'>
* {font-family: Verdana; font-size: 95%}
#content {font-size: 100% }
BODY {background-image: url('res/back.gif')}
A {color: black}
A:hover {color: red}
#tables {position: fixed; top: 20px; left: 20px; border: 1px solid #031DB2; padding: 5px; background-color: #B0BCFC;
}
#err {text-align: center; border: 1px solid #944; width: 400px; margin: 0 auto; padding: 5px; background-color: #FFB5B5;margin-top: 5px;}
#ok {text-align: center; border: 1px solid #016300; width: 400px; margin: 0 auto; padding: 5px; background-color: #BDFFBC;margin-top: 5px;}
#actions {border: 1px solid #E5E500; padding: 5px; background-color: #FFFF96; position: fixed; right: 20px; top: 20px; width: 300px;}
</style><body onload='document.getElementById("newdataarea").focus()'><div id='content'>
''')
# 8<-----------------------------------------------------------------------------------------------------
translate = {
	'accounts': t('аккаунты'),
	'proxy': t('прокси'),
}

act_names = {
	'duplicates': t('удалить дубли'),
	'invalid': t('удалить невалид'),
	'clear': t('очистить'),
	'spammed': t('удалить проспамленных'),
	'not_confirmed': t('удалить неподтвержденных'),
	'unknown_service': t('удалить с неизв. доменом'),
	'empty_cl': t('удалить с пустым КЛ'),
	'export': t('экспорт'),
	'sent_failed': t('удалить с ошибкой отправки'),
	'finished': t('удалить завершивших'),
	'valid': t('удалить валидные'),
	'clearcache': t('<b>очистить кеш acc_id</b>'),
	'clearflags': t('<b>удалить все флаги</b> (проспам, невалид, ...)'),
	'clearflagconfirmed': t('удалить флаги с требующих подтверждение'),
	'delete_spammed_emails': t('удалить проспамленных'),
	'create_index_accounts': t('создать индекс'),
	'delete_index_accounts': t('удалить индекс'),
}

translate = {}
dd = sql.exec('select tablename, fullname, description from _descriptions')
for p in dd:
	translate[p[0]] = [p[1], p[2]]

# 8<-----------------------------------------------------------------------------------------------------
#выводим таблицы
#

views_t = sql.exec('select name from sqlite_master where type in ("view") and name not like ("sqlite_%")')
views = [row[0] for row in views_t]

files = sql.exec('select name from sqlite_master')
files = [row[0] for row in files if not row[0].startswith('sqlite_') and not row[0].startswith('_')]

add_data = t('добавить данные')

_print('''
<script>

window.actions = new Array()

function createMenu(id)
{
	var par = document.getElementById("p_" + id)
	var menuBlock = document.getElementById('menuBlock')

	if(id == "hide")
	{
		menuBlock.style.display = "none"
		return
	}

	menuBlock.style.display = (menuBlock.style.display == 'none') ? 'block' : 'none'

	p = document.createElement('p')
	// $(\'menuBlock\').hide() createMenu('hide'); void(0);
	newHtml = '<p style="text-align:right; background-color: #D0C32F; padding: 3px; margin: -9px -9px 5px -9px;"><a href="javascript:createMenu(\\'hide\\'); " style=\\'text-decoration: none\\'><b>X</b></a></p><a href="?table=' +id+ '&action=uploadfile&%(cnf_text2)s" style="font-weight: bold">%(add_data)s</a><br />'

	for(part in window.actions[id])
	{
		newHtml += '<a href="' + part + '">' + window.actions[id][part] + '</a><br />'
	}

	p.innerHTML = newHtml

	menuBlock.innerHTML = newHtml
	menuBlock.style.top = par.offsetTop + par.offsetHeight + 20
	menuBlock.style.left = 70

}

</script>


''' % locals())

tables_html = ''
for i, filen in enumerate(files):
	fname = filen
	if filen in translate:
		fname = translate[filen][0]
		fdesc = translate[filen][1]
		fdesc_plain = hlp.strip_tags(fdesc).replace('"', "'")

	sz = sql.size(filen)

	if filen in ['accounts', 'proxy', 'recipients', 'emails', 'message', 'messages']:
		bolder = ' style="font-weight: bold" '
	else:
		bolder = ''

	fname_trans = cnf.lang_rows.get(fname, fname)

	if filen not in views:
		tables_html += '''<p id="p_%(filen)s"
style='margin: 0; margin-bottom: 1px'><input type="checkbox" name="to_clear[]" value="%(filen)s" /> <img
onclick='createMenu("%(filen)s")'
src='res/edit.jpg' alt='edit' /> <a href="?table=%(filen)s&%(cnf_text2)s"%(bolder)s title="%(fdesc_plain)s" >%(fname_trans)s</a><small style="color: #666"> %(sz)d</small></p>''' % locals()

import sqlite3
#~
conn = sqlite3.connect(db_path, isolation_level='IMMEDIATE')
#~
#~ cursor = conn.cursor()
#~ FLAGS = cursor.execute('select value from _settings where option="flags"').fetchall()[0][0]
#~ cursor.close()
#~
#~ def ex(sql):
	#~ cursor = conn.cursor()
	#~ data = cursor.execute(sql).fetchall()[0][0]
	#~ cursor.close()
	#~ return data
#~
#~ str_1 = 'select count(data) from accounts'
#~ t_1 = ex(str_1)
#~
#~ str_2 = 'select count(data) from accounts where finished = 1'
#~ t_12 = ex(str_2)
#~
#~ str_3 = 'select count(data) from accounts where valid = 1 and finished = 1'
#~ t_2 = ex(str_3)
#~
#~ str_4 = 'select count(data) from accounts where invalid = 1'
#~ t_3 = ex(str_4)
#~
#~ str_5 = 'select count(data) from accounts where empty_cl = 1'
#~ t_4 = ex(str_5)
#~
#~ str_7 = 'select count(data) from accounts where valid = 1 and finished = 0 and empty_cl = 0'
#~ t_6 = ex(str_7)
#~
#~ str_9 = 'select count(data) from accounts where unknown_service = 1'
#~ t_13 = ex(str_9)
#~
#~ str_6 = 'select count(data) from accounts where valid = 0 and invalid = 0 and unknown_service = 0'
#~ t_5 = ex(str_6)
#~ #t_5 = int(t_5) + int(t_13)
#~
#~ str_8 = 'select count(data) from accounts where finished = 1 and invalid = 1'
#~ t_12 = int(t_12) + int(t_3) + int(t_13)
#~
#~ tword0 = t('аккаунты')
#~ tword1 = t('всего')
#~ tword2 = t('не начинали')
#~ tword3 = t('не закончили')
#~ tword4 = t('закончили')
#~ tword5 = t('валид')
#~ tword6 = t('невалид')
#~ tword7 = t('пустой КЛ')
#~ tword8 = t('неизв. сервер')
#~
#~ t_accs = '''<p><b>%(tword0)s</b><br />
#~ <span title='%(str_1)s'>%(tword1)s - %(t_1)s</span><br />
#~ &#151; <span title='%(str_6)s'>%(tword2)s - %(t_5)s</span><br />
#~ &#151; <span title='%(str_7)s'>%(tword3)s - %(t_6)s</span><br />
#~ &#151; <span title='%(str_2)s'>%(tword4)s - %(t_12)s</span><br />
#~ &#151;&#151; <span title='%(str_3)s'>%(tword5)s - %(t_2)s</span><br />
#~ &#151;&#151; <span title='%(str_4)s'>%(tword6)s - %(t_3)s</span><br />
#~ &#151;&#151; <span title='%(str_5)s'>%(tword7)s - %(t_4)s</span><br />
#~ &#151;&#151; <span title='%(str_9)s'>%(tword8)s - %(t_13)s</span><br />
#~ </p>''' % locals()
#~
#~
#~ e_1 = ex('select count(data) from emails')
#~ e_2 = ex('select count(data) from emails where uid is not null')
#~ e_3 = ex('select count(data) from emails where uid is null')
#~
#~ tword0 = t('имейлы из КЛ')
#~ tword2 = t('проспам')
#~ tword3 = t('неспам')
#~ t_emails = '''<p><b>%(tword0)s</b><br />
#~ <span title='%(e_1)s'>%(tword1)s - %(e_1)s</span><br />
#~ &#151; %(tword2)s - %(e_2)s<br />
#~ &#151; %(tword3)s - %(e_3)s</p>''' % locals()
#~
#~ p_1 = ex('select count(data) from proxy')
#~ p_2 = ex('select count(data) from proxy where type = 0')
#~ p_3 = ex('select count(data) from proxy where type = 1')
#~ p_4 = ex('select count(data) from proxy where type = 2')
#~ p_5 = ex('select count(data) from proxy where type = 3')
#~
#~ tword0 = t('прокси')
#~ t_proxy = '''<p><b>%(tword0)s</b><br />
#~ всего - %(p_1)s<br />
#~ &#151; http - %(p_2)s<br />
#~ &#151; socks5 - %(p_3)s<br />
#~ &#151; auto - %(p_4)s</p>''' % locals()
#~
#~ r_1 = ex('select count(auto_id) from recipients')
#~ r_2 = ex('select count(auto_id) from recipients where invalid = 1')
#~ r_3 = ex('select count(auto_id) from recipients where spammed = 1')
#~ r_4 = ex('select count(auto_id) from recipients where sent_failed = 1')
#~
#~ tword0 = t('получатели')
#~ tword1 = t('всего')
#~ tword3 = t('ошибка отпр.')
#~
#~ t_recip = '''<p><b>%(tword0)s</b><br />
#~ %(tword1)s - %(r_1)s<br />
#~ &#151; %(tword6)s - %(r_2)s<br />
#~ &#151; %(tword2)s - %(r_3)s<br />
#~ &#151; %(tword2)s - %(r_4)s</p>''' % locals()
#~
#~
#~ def get_langs():
	#~ sql = 'select lang from accounts where lang is not null'
	#~ cursor = conn.cursor()
	#~ langs = cursor.execute(sql).fetchall()
	#~ cursor.close()
	#~ langs = [v[0] for v in langs]
#~
	#~ langs_uniq = list(set(langs))
#~
	#~ text = ''
	#~ for l in langs_uniq:
		#~ text += '<b>{0}</b>: {1}, '.format(l, langs.count(l))
	#~ return text
#~ print(langs)
#~ langs = ', '.join(langs)
#~ return langs
#~
#~
#~ if os.path.exists('res/lang'):
	#~ langs = get_langs()
	#~ t_lang = '''<p><b>langs</b><br />
#~ %(langs)s<br />
#~ </p>''' % locals()
#~ else:
	#~ t_lang = ''
#~
#~
#~ tword0 = t('Статистика')
#~ stats = '''
#~ <a href='javascript:return undefined' style='display: none; text-decoration: none; border-bottom: 1px dotted black; margin-left: 100px'>%(tword0)s</a>
#~ </div>
#~
#~ <div style='border: 1px solid black; position: fixed; top: 10px; right: 20px;
#~ width: 200px; background-color: #F8F865; padding: 10px' id='statpad'>
#~ <center style='font-weight: bold'>Stats</center>
#~ %(t_accs)s
#~ %(t_emails)s
#~ %(t_proxy)s
#~ %(t_recip)s
#~ %(t_lang)s
#~ </div>
#~ ''' % locals()
stats = ''

tword1x = t('выход')
tword0 = t('данные')
tword1 = t('очистить выделенные')
trrrword = t('тестер сообщений')
trrrword2 = t('SQL')

_print('''<form method="post" action='fileed_sql.py?table=&%(cnf_text2)s'><input type="hidden" name="mass_clear" value="1">

<span id='menuBlock' style='border: 1px solid black; background-color: #FFFFB9; position: absolute;
z-index: 999999999; padding: 10px; display: none;
'></span>

<div id="tables">
<p>
&nbsp;&nbsp;<a href='start.pyw%(cnf_text)s' style='font-weight: bold'>&larr; %(tword1x)s</a>&nbsp;&nbsp;&bull;
<!--<a href='message_test.py'>%(trrrword)s</a>&nbsp;&nbsp;&bull;-->&nbsp;&nbsp;<a href='?custom_request=1&%(cnf_text2)s'>%(trrrword2)s</a></p>
<p style="text-align: center; font-weight: bold"><a href="fileed_sql.py?table=proxy&%(cnf_text2)s">%(tword0)s</a></p>%(tables_html)s<p style="text-align: center"><input type="submit" value="%(tword1)s" /></p>

%(stats)s</div>

</form>''' % locals())

# 8<-----------------------------------------------------------------------------------------------------
# действия для таблицы

for table in files:
	actions = ['clear', 'export', 'duplicates']

	if table == 'accounts':
		actions.append('invalid')
		actions.append('not_confirmed')
		actions.append('clearcache')
		actions.append('clearflags')
		actions.append('clearflagconfirmed')
		actions.append('create_index_accounts')
		actions.append('delete_index_accounts')

	if table == 'recipients':
		actions.append('duplicates')
		actions.append('spammed')
		actions.append('sent_failed')

	if table == 'emails':
		actions.append('delete_spammed_emails')

	for view in views:
		if view.startswith(table):
			actions.append(view)
			act_names[view] = t('смотреть') + ' ' + translate[view][0]

	if actions and table not in views:
		act_line = ''
		for act in actions:
			if act not in act_names:
				aname = act
			else:
				aname = act_names[act]
			if aname.startswith(t('смотреть')):
				act_line += '"?table=%s&%s": "%s", ' % (act, cnf_text2, aname)
			else:
				act_line += '"?table=%s&act=%s&%s": "%s", ' % (table, act, cnf_text2, aname)

	_print('''<script>window.actions['%s'] = {%s}</script>''' % (table, act_line))


# 8<-----------------------------------------------------------------------------------------------------
# если не задана таблица
#~ if 'table' not in form and 'custom_request' not in form:
	#~ _print('<div id="err">' + t('не задана таблица с данными') + '</div>')
	#~ sys.exit(0)

# 8<-----------------------------------------------------------------------------------------------------
if 'custom_request' in form:

	table = '_custom'
	views.append(table)
else:
	table = form.getvalue('table', files[1])

#	выводим таблицу
if table not in files and table not in views:
	_print('<div id="err">' + t('неизвестная таблица') + '</div>')
	sys.exit(0)

# 8<-----------------------------------------------------------------------------------------------------

if os.environ['REQUEST_METHOD'] == 'POST' and 'custom_request' not in form:

	if form.getvalue('mass_clear') == '1':
		table = ''
		to_clear = form.getvalue('to_clear[]')

		if isinstance(to_clear, str):
			to_clear = [to_clear]

		if isinstance(to_clear, list) and len(to_clear):
			for table_n in to_clear:
				sql.clear(table_n)

			hlp.redir('fileed_sql.py?table=')

	#if 'mass_clear' in form
	#обрабатываем пост
	data = form.getvalue('newdata') if 'newdata' in form else ''

	mode = 'add' if form.getvalue('save') == t('добавить') else 'save'

	split = True
	if table in ['message']:
		split = False

	cols = None
	if table in ['proxy']:
		sql.table_cols['proxy'] = '?, ' + form.getvalue('proxytype')

	if mode == 'save':
		sql.clear(table)
		mode = 'add'

	if mode == 'add':
		gd = getData()
		data = gd.main_get(form)
		sql_query = gd.get_sql(sql, table)

		def generator(rows):
			for row in rows:
				yield (row,)

		cursor = conn.cursor()
		cursor.executemany(sql_query, generator(data))
		cursor.close()

		conn.commit()

		_print('<div id="ok">' + t('выполнено') + '</div>')
		sys.exit(0)

	 #~ and 'lang' in form:
		#~ if form.getvalue('lang') == 'null':
			#~ cols = 'null, "%s", 0,0,0,0,0,0, null'
		#~ else:
			#~ cols = 'null, "%s", 0,0,0,0,0,0, "' + form.getvalue('lang') + '"'

	if table in ['fails_texts']:
		cols = '"%s", ' + '"%s"' % form.getvalue('failtype')


	if mode == 'add':
		sql.add(table, data, cols=cols, split=split)
	else:
		if 'newfile' not in form:
			sql.save(table, data, cols=cols, split=split)

	_print('<div id="ok">' + t('выполнено') + '</div>')
	sys.exit(0)

# 8<-----------------------------------------------------------------------------------------------------
# если задано действие, типа Удалить дубли
if 'act' in form:
	action = form.getvalue('act')

	if action == 'duplicates':
		sql.unique(table)
	elif action == 'spammed':
		sql.exec('delete from %s where spammed = 1' % table)
	elif action == 'not_confirmed':
		sql.exec('delete from %s where not_confirmed = 1' % table)
	elif action == 'export':
		hlp.redir('?table=%s&exporttype=plain' % table)
	elif action == 'empty_cl':
		sql.exec('delete from %s where empty_cl = 1' % table)
	elif action == 'sent_failed':
		sql.exec('delete from %s where sent_failed = 1' % table)
	elif action == 'unknown_service':
		sql.exec('delete from %s where unknown_service = 1' % table)
	elif action == 'finished':
		sql.exec('delete from %s where finished = 1' % table)
	elif action == 'valid':
		sql.exec('delete from %s where valid = 1' % table)
	elif action == 'delete_spammed_emails':
		sql.exec('delete from emails where uid is not null')
	elif action == 'clearcache':
		sql.exec('delete from _acc_id')
	elif action == 'clearflags':
		sql.exec('update accounts set invalid = 0')
		sql.exec('update accounts set not_confirmed = 0')
		sql.exec('update accounts set processed = 0')
	elif action == 'clearflagconfirmed':
		sql.exec('update accounts set not_confirmed = 0')
	elif action == 'clear':
		sql.clear(table)
	elif action == 'invalid':
		sql.exec('delete from %s where invalid = 1' % table)
	elif action == 'create_index_accounts':
		sql.exec('CREATE INDEX "_accounts_data" on accounts (data ASC)')
	elif action == 'delete_index_accounts':
		sql.exec('DROP INDEX "_accounts_data"')

	_print('<div id="ok">' + t('действие') + ' "<i>%s</i>" ' % act_names[action] + t('выполнено') + '</div>')
	sys.exit(0)

# 8<-----------------------------------------------------------------------------------------------------
where = ''
if 'where' in form:
	where = form.getvalue('where')

if 'custom_request' in form:

	if os.environ['REQUEST_METHOD'] == 'POST':
		new_sql = form.getvalue('new_sql')

		sql_history = '' # сохраняем в файл engine/sql_history
		if not hlp.exists('engine/sql_history'):
			with open('engine/sql_history', 'w') as fp:
				pass

		if new_sql.count(';') < 2:

			desc = t('Результаты запроса') + ': ' + new_sql
			body = sql.exec(new_sql)
			if body is False:
				body =  new_sql
				desc = '<span style="color: red">%s</span>' % t('Неправильный запрос')
				rows = []
			else:
				rows = [hlp.unquote(str(r[0])) for r in body]
				body = "\n".join(rows)
				sql_history = new_sql + ': OK\n'

		# если запросов несколько
		else:

			sqls = [v.strip() for v in new_sql.split(';') if v.strip()]

			body = ''
			rows = []
			desc = 'результаты выполнения {0} запросов'.format(len(sqls))
			for sql_t in sqls:

				result = sql.exec(sql_t)
				if result is False:
					body += sql_t +': Failed\n'
				else:
					body += sql_t +': OK\n'

			sql_history = body

		if sql_history.strip():
			with open('engine/sql_history', 'a') as fp:
				fp.write('-----{0}-----\n'.format(hlp.human_date(format_d="%d.%m.%y %H-%M-%S")))
				fp.write(sql_history)

	else:
		desc = t('Запрос к БД')

		desc += '<br /><br />немного статы по доменам:'
		rows = []

		serv_data = sql.getlist('servers')
		serv_dict = {}

		for servline in serv_data:
			if servline.startswith('#'):
				continue

			servline = hlp.unquote(servline)

			servname, doms = servline.split('=')
			if ';' not in doms:
				doms = [doms]
			else:
				doms = doms.split(';')
			serv_dict[servname] = doms

else:
	rows = sql.getlist(table, unique=False, valid=False, where2=where)
	body = "\n".join(rows)

# дополнительные опции для разных таблиц
if table == 'proxy':
	addHtml = t('тип прокси') + ''': <select name="proxytype">
	<option value="0">http</option>
	<option value="1">socks5</option>
	<option value="2">https</option>
	<option value="3">auto</option>
</select>'''

elif table == 'OLDaccounts' and os.path.exists('res/lang'): #### удалено
	addHtml = t('язык') + ''': <select name="lang">
<option value='null'>--</option>
<option value='el'>el</option>
<option value='en'>en</option>
<option value='cn'>cn</option>
<option value='vi'>vi</option>
<option value='it'>it</option>
<option value='eu'>eu</option>
<option value='ar'>ar</option>
<option value='cs'>cs</option>
<option value='et'>et</option>
<option value='id'>id</option>
<option value='es'>es</option>
<option value='ru'>ru</option>
<option value='nl'>nl</option>
<option value='pt'>pt</option>
<option value='no'>no</option>
<option value='tw'>tw</option>
<option value='tr'>tr</option>
<option value='lv'>lv</option>
<option value='ro'>ro</option>
<option value='pl'>pl</option>
<option value='fr'>fr</option>
<option value='bg'>bg</option>
<option value='uk'>uk</option>
<option value='hr'>hr</option>
<option value='de'>de</option>
<option value='da'>da</option>
<option value='br'>br</option>
<option value='fi'>fi</option>
<option value='hu'>hu</option>
<option value='ja'>ja</option>
<option value='he'>he</option>
<option value='sr'>sr</option>
<option value='ko'>ko</option>
<option value='sv'>sv</option>
<option value='sk'>sk</option>
<option value='ms'>ms</option>
<option value='sl'>sl</option>
</select>'''
elif table == 'fails_texts': #################################################

	p = [n.replace('.py', '') for n in os.listdir('include/mail_mods/') if '.py' in n and 'init' not in n]

	addHtml = t('модуль') + ': <select name="failtype">'
	for mod in p:
		addHtml += '<option value="%s">%s</option>' % (mod, mod)

	addHtml += '</select>'

else:
	addHtml = ''

if table in translate:
	tablename = translate[table][0]
	desc = translate[table][1]
else:
	tablename = table

# 8<-----------------------------------------------------------------------------------------------------
#	выводим форму для загрузки файла / добавления данных в таблицу
if 'action' in form and form.getvalue('action') == 'uploadfile':

	if os.environ['REQUEST_METHOD'] == 'POST':

		# запускаем
		gd = getData()
		data = gd.main_get(form)
		sql_query = gd.get_sql(sql, table)

		def generator(rows):
			for row in rows:
				yield (row,)

		cursor = conn.cursor()
		cursor.executemany(sql_query, generator(data))
		cursor.close()

		conn.commit()
		sys.exit(0)

	tword2 = t('таблица')
	tword3 = t('добавить')
	tword4 = t('или добавить через поле')
	tword5 = t('Локальный файл')
	tword6 = t('и')

	tablename_trans = cnf.lang_rows.get(tablename, tablename)

	_print('''
<form method='post' enctype="multipart/form-data" action='fileed_sql.py?table=%(table)s&action=uploadfile&method=file&%(cnf_text2)s'>
<p style='text-align: center'>%(tword2)s <a href='?table=%(table)s&%(cnf_text2)s'><b>%(tablename_trans)s</b></a> <small>(%(sz)d)</small></p>
<p style='width: 500px; margin: 0 auto; background-color: #eee; padding: 5px'>%(desc)s</p>
<p style='text-align: center'>''' % locals())

	_print(t('Загрузить файл') + ''' <input type='file' name='newfile' size='10' /> %(addHtml)s %(tword6)s <input type='submit' name='save' value='%(tword3)s' /></form>

<form method='post' action='fileed_sql.py?table=%(table)s&action=uploadfile&method=local_file&%(cnf_text2)s'>
<p style='text-align: center'>%(tword5)s <input type='text' name='local_name' />
%(addHtml)s %(tword6)s
<input type='submit' name='save' value='%(tword3)s' /></p>
</form>
</p>
<form method='post' action='fileed_sql.py?table=%(table)s&%(cnf_text2)s'>
<p style='text-align: center'> %(tword4)s:<br /> <textarea cols='70' name='newdata' id='newdataarea' rows='20'></textarea><br />''' % locals())

	_print('''<br />
%(addHtml)s&nbsp;&nbsp;&nbsp;<input type='submit' name='save' value='%(tword3)s' style='width: 200px; height: 50px' /></form></p>''' % locals())

	sys.exit(0)

tword1 = t('выход')
tword2 = t('таблица')
tablename_trans = cnf.lang_rows.get(tablename, tablename)

sz = len(rows)
_print('''
<form method='post' action='fileed_sql.py?table=%(table)s&%(cnf_text2)s'>
<p style='text-align: center'>%(tword2)s <a href='?table=%(table)s&%(cnf_text2)s'><b>%(tablename_trans)s</b></a> <small>(%(sz)d)</small></p>
<p style='width: 500px; margin: 0 auto; background-color: #eee; padding: 5px'>%(desc)s</p>''' % locals())


if 'custom_request' in form and 'new_sql' not in form:
	_print('''</form>
<form method='post' action='?custom_request=1&%(cnf_text2)s'><p style='text-align: center'>
<textarea name='new_sql' id='new_sql' cols='70' rows='20'>select * from where</textarea><br />
<input type='submit' value='Exec' />
</form>
''' % locals())
elif 'custom_request' in form and 'new_sql' in form:
	_print('''</form>
<form method='post' action='?custom_request=1&%(cnf_text2)s'><p style='text-align: center'>
<textarea name='new_sql' cols='70' rows='20'>%(body)s</textarea><br />
<input type='submit' value='Exec' />
</form>
''' % locals())
else:
	_print('''<p style='text-align: center'><textarea cols='70' name='newdata' id='newdataarea' rows='20'>%(body)s</textarea><br />''' % locals())
#(table, tablename, len(rows), desc, body)

# 8<-----------------------------------------------------------------------------------------------------

if table in views:
	editButtons = t('режим просмотра')
else:
	tword3 = t('сохранить')
	editButtons = '''<input type='submit' value='%(tword3)s' name='save' style='font-weight: bold; width: 200px; height: 50px' />''' % locals()


_print('''<p style='text-align: center'>%s&nbsp;&nbsp;&nbsp;%s</p>
</form></div>

<script>
function shit()
{
	alert(1)
	$("#menuBlock").hide();
}

//$("#content  :not(img)").bind("click", shit);

</script>
''' % (addHtml, editButtons))



