# coding=utf-8
from engine.as_sqlite import asSqlite
from engine.as_sqlite import asSqlite_deferred
from engine.as_http import asHttp
from engine.as_ac import asAc
from engine.as_hlp import hlp


class ThreadBody:
    ''' Бот. Сама работа. Никаких конфигов '''
    def init(self, module, tid=0):
        parent = module.parent
        self.tid = tid
        self.data = module.data
        self.file = parent.file
        self.cnf = parent.cnf
        self.hlp = parent.hlp
        self.sqlite = asSqlite_deferred(self.cnf.getbool('sqldebug'), parent=parent)
        self.http_no_proxy = asHttp(parent, self.cnf.getbool('httpdebug'))
        self.log_main = parent.log
        self.proxy = parent.proxy
        self.queue = parent.queue
        self.threadsStopped = parent.threadsStopped
        self.http = asHttp(parent, self.cnf.getbool('httpdebug'), tid=tid)
        if self.proxy.change(self.http) == 'no proxies':
            self.log('нет прокси для запуска', '!')
            return 'skip'
        self.ac = asAc(parent=parent, key=self.cnf.get('ac_key'),
            ctype=self.cnf.get('ac_type'), http=self.http_no_proxy, tid=tid, http_main=self.http)
        return True

    def log(self, text, ctype=''):
        self.log_main(text, ctype=ctype, tid=self.tid)

    def login(self, acc):
        if acc.count(':') == 1:
            login, password = acc.replace(';',':').split(':')
        else:
            self.log('Неверный формат аккаунта!' + acc,  '!')
            self.sqlite.upd('accounts', acc, 'invalid=1')
            return False
        login_name = login.split ('@')[0]
        domain = login.split ('@')[1]
        self.login_text = login_name
        self.password = password
        #self.http.clear_cookies().get('http://my.mail.ru')
        self.http.get('http://my.mail.ru')
        self.log('входим в акк <b>{0}</b>'.format(acc))
        data = {
            'page': 'http://my.mail.ru',
            'FailPage': 'http://my.mail.ru/cgi-bin/login?fail=1',
            'Login': login_name,
            'Domain': domain,
            'Password': password,
            }
        page = self.http.post('https://auth.mail.ru/cgi-bin/auth', data)
        page = self.http.get('http://my.mail.ru')
        if '/search_people" class="js-form' in page:
            self.log('зашли в акк <b>{0}</b>'.format(acc))
        else:
            self.log('Не удалось зайти в акк <b>{0}</b>'.format(acc), '!')
            return False

    def grab (self, ankpage):
        '''собираем анкеты'''
        '''
        http://my.mail.ru/bk/neprinimayu/
        http://my.mail.ru/mail/prohorgromow/
        <a href="http://my.mail.ru/mail/nice.girl2011/">  - попробуем распарсить это
        '''
        self.log('Открываем страницу ' + ankpage, '+')
        page = self.http.get(ankpage)
        if 'id="alien"' in page:  #input id="alien"
            self.log('Нам не верят, просят залогиниться...')
            return 'LOGIN'
        # Возможно, добавить проверок, а не просят ли нас бля залогиниться?
        alist = hlp.parse_all(r'<a href="http://my.mail.ru/mail/([\d,\w^"]+)', page)
        if alist is False:
            if 'По вашему запросу ничего не найдено' in page:
                return 'NOTFOUND'
            #return False
            alist = []
        if len(alist) > 0:
            for i in alist:
                if len(i) == 1:
                    alist.remove(i)
            self.log('Собрали ' + str(len(alist)) + ' пользователей.', '+')
        else:
            self.log('0 Пользователей на странице', '+')
        return alist

    def walk(self, ankid):
        '''Посещаем страницу'''
        # Анкеты собираются в модуле. здесь всего лишь заходим на чью-то страницу
        # формируем запрос.
        ankpg = 'http://my.mail.ru/mail/{0}/'.format(ankid)
        self.log('Открываем страницу ' + ankpg, '+')
        page = self.http.get(ankpg)
        if 'id="alien"' in page:  #input id="alien"
            self.log('Нам не верят, просят залогиниться...')
            return 'LOGIN'
        self.hlp.slp(1)
        # Добавляем действие в анкете.
        if 'http://my.mail.ru/mail/{0}/photo'.format(ankid) in page:
            self.log('Открываем страницу с фотографиями...', '+')
            photopg = 'http://my.mail.ru/mail/{0}/photo'.format(ankid)
            self.hlp.slp(1)
            page = self.http.get(photopg)
            if 'http://my.mail.ru/mail/{0}/photo?album_id=_myphoto'.format(ankid) in page:
                self.log('Открываем альбом пользователя..', '+')
                ankphoto = self.http.get('http://my.mail.ru/mail/{0}/photo?album_id=_myphoto&booster=1'.format(ankid))
                if ankphoto is False:
                    self.log('Не удалось зайти в альбом пользователя!', '!')
                    return False
                self.log('Успешно посетили альбом id ' + ankid, '+')
                self.sqlite.rm('user_id', ankid)
                self.hlp.slp(self.cnf.get('wlk_slp'))
                return 'OK'
            else:
                self.log('Не смогли найти альбомы пользователя!', '!')
                return 'NoAlb'
        else:
            self.log('Успешно посетили id ' + ankid, '+')
            self.sqlite.rm('user_id', ankid)
            self.hlp.slp(self.cnf.get('wlk_slp'))
            return 'OK'

    def stop_chk(self):
        '''Проверяем, не стопаем ли движок'''
        dbtest = len(self.sqlite.getlist('accounts'))
        if dbtest < 1:
            return 'STOP'
        else:
            return 'OK'
