from engine.as_hlp import hlp
from engine.as_bot import asBot
from include.lib import ThreadBody
#import re

class grabber(asBot):
    '''
    <name>Граббер</name>
    <descr>Собираем ID пользователей для гулялки</descr>
    '''

    def __init__(self, parent):
        '''init'''
        super(self.__class__, self).__init__(parent)
        self.parent = parent
        self.parent.tid = 0

    def start(self):
        '''start'''
        if not self.preload_tables(['accounts']):
            return
        account = self.sqlite.getlist('accounts', unique=True, valid=True, where2='not_confirmed=0')
        acc_sz = len(account)
        if not acc_sz:
            self.log('нет акков', '!')
            return False
        acco = [account.pop(0)]
        self.threads.process(1, acco, self.work)

    def work(self, acc, tid):
        ''' обрабатываем акк '''
        tb = ThreadBody()
        res = tb.init(self, tid)
        if res is not True:
            return res
        res = tb.login(acc)
        if res is False:
            tb.log('не смогли залогиниться','!')
            return False
        """
        http://my.mail.ru/my/search_people - Страница с обычным поиском.
        http://my.mail.ru/my/online-users - Страница с онлайн-пользователями
        """
        # STOPCHECK
        stopme = tb.stop_chk()
        if stopme == 'STOP':
            tb.log('Останавливаемся...', '+')
            return False

        anklist = []
        ank_max = self.cnf.get('walker_grab_max')
        walk_type = self.cnf.get('walker_type')
        #tb.log('walk_type = "' + walk_type + '"', '+') # TODO : Delete
        if walk_type == '1':
            ankpage = 'http://my.mail.ru/my/online-users' # Онлайн
            while int(len(anklist)) < int(ank_max):
                # STOPCHECK
                stopme = tb.stop_chk()
                if stopme == 'STOP':
                    tb.log('Останавливаемся...', '+')
                    return False
                tb.log('Собираем анкеты из онлайна...', '+')
                res = tb.grab(ankpage)
                if res is False:
                    #tb.log('res is False') # TODO : Delete
                    return False
                if res == 'LOGIN':
                    tb.log('Попробуем заново зайти..', '+')
                    logagain = tb.login(acc)
                    if logagain is False:
                        tb.log('не смогли залогиниться','!')
                        return False
                    continue
                elif len(res) > 0:
                    anklist.extend(res)
                self.hlp.cnt('grab_p')
                self.hlp.slp(self.cnf.get('grab_slp'))
                # STOPCHECK
                stopme = tb.stop_chk()
                if stopme == 'STOP':
                    tb.log('Останавливаемся...', '+')
                    return False
        else:
            ankpage = self.cnf.get('grab_link') # Критерии
            p = 1
            while len(anklist) < int(ank_max):
                # STOPCHECK
                stopme = tb.stop_chk()
                if stopme == 'STOP':
                    tb.log('Останавливаемся...', '+')
                    return False
                tb.log('Собираем анкеты по критериям...', '+')
                res = tb.grab(ankpage + '&p=' + str(p))
                if res == 'NOTFOUND':
                    tb.log('Ничего не нашли по запросу.', '!')
                    break
                if res is False:
                    #tb.log('res is False') # TODO : Delete
                    return False
                if res == 'LOGIN':
                    tb.log('Попробуем заново зайти..', '+')
                    logagain = tb.login(acc)
                    if logagain is False:
                        tb.log('не смогли залогиниться','!')
                        return False
                    continue
                elif len(res) > 0:
                    anklist.extend(res)
                p += 1
                self.hlp.cnt('grab_p')
                self.hlp.slp(self.cnf.get('grab_slp'))
                # STOPCHECK
                stopme = tb.stop_chk()
                if stopme == 'STOP':
                    tb.log('Останавливаемся...', '+')
                    return False
        #Удаляем повторения
        tb.log('Чистим список от дублей...', '+') # TODO : Delete
        seen = set()
        seen_add = seen.add
        anklist = [ x for x in anklist if x not in seen and not seen_add(x)]

        if len(anklist) > int(ank_max):
            excess = int(len(anklist)) - int(ank_max)
            #tb.log('излишек = ' + str(excess), '+') # TODO : Delete
            anklist[0:excess] = []
        tb.sqlite.add('user_id', anklist)
        #tb.log('список теперь выглядит как {0}'.format(anklist), '+') # TODO : Delete
        #tb.log('количество элементов списка : ' + str(len(anklist)), '+') # TODO : Delete
        return
