# coding=utf-8
from engine.as_hlp import hlp
from engine.as_bot import asBot
from include.lib import ThreadBody

class walker(asBot):
    '''
    <name>Гулялка</name>
    <descr>бродим по страницам пользователей</descr>
    '''

    def __init__(self, parent):
        '''init'''
        super(self.__class__, self).__init__(parent)
        self.parent = parent
        self.parent.tid = 0

    def start(self):
        '''подготовка'''
        if not self.preload_tables(['accounts']):
            return
        accounts = self.sqlite.getlist('accounts', unique=True, valid=True, where2='not_confirmed=0')
        acc_sz = len(accounts)
        if not acc_sz:
            self.log('нет акков', '!')
            return False

        threads = self.cnf.getint('threads')
        if threads > acc_sz:
            n = acc_sz
        else:
            n = threads
        self.data['userslist'] = self.sqlite.getlist('user_id')
        self.log('запускаем {0} потоков'.format(n))
        self.threads.process(n, accounts, self.work)

    def work(self, acc, tid):
        ''' обрабатываем акк '''
        tb = ThreadBody()
        res = tb.init(self, tid)
        if res is not True:
            return res
        #tb.log('Thread ID: ' + str(tid), '+') # debug puposes
        if len(self.data['userslist']) < 1:
            tb.log('Анкеты закончились.', '!')
            return False
        # STOPCHECK
        stopme = tb.stop_chk()
        if stopme == 'STOP':
            tb.log('Останавливаемся...', '+')
            return False

        tb.log('Аккаунт ' + acc, '+')
        res = tb.login(acc)
        if res is False:
            tb.log('не смогли залогиниться','!')
            return False
        #Устанавливаем лимит
        wlimit = self.cnf.get('wlk_limit')
        ulist = self.data['userslist']
        if int(wlimit) < len(ulist):
            nlimit = wlimit
        else:
            nlimit = len(ulist)
        for i in range(int(nlimit)):
            #tb.log('Ulist = ' + str(ulist), '+') # TODO : Delete This!
            if len(ulist) < 1:
                tb.log('Анкеты закончились.', '!')
                break
            else:
                ank = ulist.pop(0)
            res = tb.walk(ank)
            if res is False:
                self.hlp.cnt('fail')
                return False
            if res == 'LOGIN':
                tb.log('Попробуем заново зайти..', '+')
                logagain = tb.login(acc)
                if logagain is False:
                    tb.log('не смогли залогиниться','!')
                    #return False # Не будем категоричными, попробуем новую анкету
                    continue # Выходим из цикла
                res = tb.walk(ank)
                if res is False:
                    self.hlp.cnt('fail')
                    return False
            if res == 'OK':
                tb.log('Успешно посетили id ' + ank, '+')
                self.hlp.cnt('walk')
            if res == 'NoAlb':
                continue
            #if len(ulist) < 1:
                #tb.log('Анкеты закончились.', '!')
                #break
            stopme = tb.stop_chk()
            if stopme == 'STOP':
                tb.log('Останавливаемся...', '+')
                return False
        return



